program incdisptrans_cm
version 13.1

syntax, yearlist(numlist) cell(varname) savebs(string asis) saveresults(string asis)

  sort year
  qui gen row=_n
  foreach v of varlist cm_* {
    qui gen xt_`v'=.
    }
  local ny : word count `yearlist'
  qui gen yidx=.
  forvalues i=1/`ny' {
    local y : word `i' of `yearlist'
    di `y'
    sum row if year==`y', meanonly
    local r1=r(min)
    local r2=r(max)
    qui replace yidx=`i' in `r1'/`r2'
    foreach v of varlist cm_* {
      qui xtile temp=`v' in `r1'/`r2', nq(3)
      qui replace xt_`v'=temp in `r1'/`r2'
      drop temp
      }
    }
  drop row
  qui xtset `cell' yidx
  foreach v of varlist cm_* {
    qui {
      gen byte q1_`v'=(xt_`v'==1)
      gen byte q3_`v'=(xt_`v'==3)
      gen byte q1q1_`v'=q1_`v' if L.q1_`v'==1
      gen byte q1q3_`v'=q3_`v' if L.q1_`v'==1
      gen byte q3q1_`v'=q1_`v' if L.q3_`v'==1
      gen byte q3q3_`v'=q3_`v' if L.q3_`v'==1
      }
    }
  save `savebs'
  collapse (mean) q1q1_* q1q3_* q3q1_* q3q3_*, by(year) fast
  foreach w in q1q1 q1q3 q3q1 q3q3 {
    egen `w'_m_bs=rowmean(`w'_cm_bs*)
    egen `w'_se_bs=rowsd(`w'_cm_bs*)
    gen `w'_v_bs=`w'_se_bs*`w'_se_bs
    gen `w'_bias_bs=`w'_m_bs-`w'_cm_orig
    gen `w'_bc=`w'_cm_orig-`w'_bias_bs
    egen `w'_bs_p5=rowpctile(`w'_cm_bs*), p(5)
    egen `w'_bs_p95=rowpctile(`w'_cm_bs*), p(95)
    gen `w'_ub=2*`w'_cm_orig-`w'_bs_p5
    gen `w'_lb=2*`w'_cm_orig-`w'_bs_p95
    }
  save `saveresults'

end
