log using f0-sippextract.log, replace
version 13.1
include paths.do

*SIPP

*extracts from full panel files
foreach y in 85 86 87 88 90 91 92 93 {
  if `y'<=87 {
    local state="state_"
    local suid "su_id"
    }
  else {
    local suid "pp_id"
    if `y'==92 local state "geo_st0"
    else local state "geo_ste"
    }
  if `y'==84 {
    local psu "hs_hsc"
    local stratum ""
    }
  else if inlist(`y',86,87) {
    local psu "hsc"
    local stratum "strat"
    }
  else {
    local psu "halfsamp"
    local stratum "varstrat"
    }
  if `y'==92 {
    local att_sch4 "att_sc04"
    local grd_cmp4 "grd_cm04"
    local higrade4 "higrad04"
    local in_af_4 "in_af_04"
    }
  else {
    local att_sch4 "att_sch4"
    local grd_cmp4 "grd_cmp4"
    local higrade4 "higrade4"
    local in_af_4 "in_af_4"
    }
  use `psu' `stratum' pp_mis04 pp_mis16 pp_mis28 pnlwgt `state'1 `state'4 `state'7 age_16 `att_sch4' `higrade4' `grd_cmp4' `in_af_4' `suid' hh_add16 ///
    using "`inputdata'/SIPPraw/sipp`y'fp.dta", clear
  save `inputdata'/SIPP/sipp`y'fp_extract.dta, replace
  }

*merged wave files
foreach y in "96" "01" "04" "08" {
  if "`y'"=="96" {
    local ds "sipp96l"
    local pnlwgt "lgtpnlwt"
    }
  else if "`y'"=="01" {
    local ds "sipp01w"
    local pnlwgt "lgtpnwt2"
    }
  else if "`y'"=="04" {
    local ds "sipp04w"
    local pnlwgt "lgtpnwt2"
    }
  else if "`y'"=="08" {
    local ds "sippl08puw"
    local pnlwgt "lgtpnwt2"
    }
  local state "tfipsst"
  if "`y'"=="01" | "`y'"=="08" local wmax 7
  else local wmax 10
  if "`y'"=="96" local yy=1900+`y'
  else local yy=2000+`y'
  local yp1=`yy'+1
  local yp2=`yy'+2
  if `wmax'==10 local yp3=`yy'+3
  *panel weights
  use ssuid epppnum `pnlwgt' using "`inputdata'/SIPPraw/sipp`y'lw.dta", clear
  save `inputdata'/SIPP/sipp`y'lw_extract.dta, replace
  *data
  forvalues w=1(3)`wmax' {
    if `w'==1 local varstuff "ghlfsam gvarstr"
    else if `w'==4 local varstuff "shhadid tage renroll eeducate eafnow"
    else local varstuff ""
    use ssuid epppnum srefmon `varstuff' tfipsst eoutcome eppintvw wpfinwgt using "`inputdata'/SIPPraw/`ds'`w'.dta", clear
    save `inputdata'/SIPP/`ds'`w'_extract.dta, replace
    }
  *replicate weights
  if "`y'"~="96" {
    use ssuid epppnum lgtwttyp repwgt* using "`inputdata'/SIPPraw/sipp`y'prw.dta" if lgtwttyp=="PN2"
    save `inputdata'/SIPP/sipp`y'prw_extract.dta, replace
    }
  }

log close
exit

