log using f15-incdisp_occsize.log, replace
version 14.0
clear all
include paths.do
set matsize `c(max_matsize)'
adopath ++ ./ado

*count number of people by occupation in 1990 census, for use in table 2

use perwt_state year occ1dig samp_incdisp_state cluster strata datanum ///
  if year==1990 ///
  using `workspace'/disp/census_fulldata.dta, clear
svyset cluster [pw=perwt_state], strata(strata) singleunit(centered)
svy, subpop(samp_incdisp_state): proportion occ1dig
mat b=e(b)
mat V=e(V)
mat list b
drop _all
set obs 9
gen share_occ=.
gen share_occ_se=.
gen occ1dig=_n
forvalues i=1/9 {
  replace share_occ=b[1,`i'] in `i'
  replace share_occ_se=sqrt(V[`i',`i']) in `i'
  }
qui save `workspace'/disp/f15-occcounts_1990se.dta, replace
sum *
desc, full

log close
