log using f17-migbyocc_table.log, replace
version 14.0
clear all
include paths.do

*make table 2 (migration and income dispersion by occupation)

use year aagrossmigwaa_occ* using graphdata/migbyocc.dta, clear
rename *_se se_*
reshape long aagrossmigwaa_occ se_aagrossmigwaa_occ, i(year) j(occ1dig)
reshape wide aagrossmigwaa_occ se_aagrossmigwaa_occ, i(occ1dig) j(year)
gen daagrossmigwaa_occ=aagrossmigwaa_occ2011-aagrossmigwaa_occ1991
gen se_daagrossmigwaa_occ=sqrt(se_aagrossmigwaa_occ2011^2+se_aagrossmigwaa_occ1991^2)
merge 1:1 occ1dig using `workspace'/disp/f15-occcounts_1990se.dta, nogen assert(match)
tempfile occsizechg
qui save `occsizechg', replace

    use occ1dig varw_bc1970 varw_bc2010 varw_se_bs1970 varw_se_bs2010 ///
      dvarw_bc_19702010 dvarw_bs_se_19702010 ///
      using graphdata/incdisp_byocc_cm_state_ydiffs.dta, clear
    merge 1:1 occ1dig using `occsizechg', nogen assert(match)
    desc, full
    rename (varw_bc* dvarw_bc_19702010 aagrossmigwaa_occ* daagrossmigwaa_occ share_occ) =_0
    rename varw_se_bs* varw_bc*_1
    rename dvarw_bs_se_19702010 dvarw_bc_19702010_1
    rename se_aagrossmigwaa_occ* aagrossmigwaa_occ*_1
    rename se_daagrossmigwaa_occ daagrossmigwaa_occ_1
    rename share_occ_se share_occ_1
    reshape long varw_bc1970_ varw_bc2010_ dvarw_bc_19702010_ aagrossmigwaa_occ1991_ aagrossmigwaa_occ2011_ daagrossmigwaa_occ_ share_occ_, i(occ1dig) j(se)
    outsheet using tabs/tab2_migbyocc_cm_state.csv, names comma replace
    local ls `c(linesize)'
    set linesize 255
    list, noobs clean
    set linesize `ls'
    corr dvarw_bc_19702010 daagrossmigwaa_occ if se==0

log close
