log using f6-scalarmoments.log, replace
version 13.1
clear all
include paths.do

*scalar moments for table 5

mat res=J(2,2,.)
mat colnames res = noncol_data col_data

*A. serial correlation of log earnings

*heads and wives
use  "`inputdata'/PSID/CleanDatasetLongCoreALL.dta" if inlist(relhh,1,2) & year<=1997 & inrange(age,23,55), clear
gen lninc=ln(labinc)
gen exper=age-yrsed-6
gen exper2=exper*exper

egen double id=group(id68 persno)
xtset id year

areg lninc exper exper2 [pw=indwgt] if inrange(yrsed,1,15), absorb(year)
predict e_nonba if e(sample), resid
corr e_nonba L.e_nonba [aw=indwgt], cov
corr e_nonba L.e_nonba [aw=indwgt]
mat res[1,1]=r(rho)

areg lninc exper exper2 [pw=indwgt] if inrange(yrsed,16,17), absorb(year)
predict e_ba if e(sample), resid
corr e_ba L.e_ba [aw=indwgt], cov
corr e_ba L.e_ba [aw=indwgt]
mat res[1,2]=r(rho)

*B. migrant-nonmigrant log earnings difference
use year serial hsba_ftpt age_full waadult ds earnwt_clean earnweek_clean2009 sex ///
  using `inputdata'/marchcps1964to2014_all.dta if inrange(year,1991,1997) & year~=1995 & earnwt_clean>0 & earnwt_clean~=., clear
gen lnearn=ln(earnweek_clean2009)
gen pophsearn=(hsba_ftpt==2 & waadult & lnearn~=.)
gen popcolearn=(hsba_ftpt==3 & waadult & lnearn~=.)
mat res2=J(7,3,.)
mat colnames res2 = year hs col
foreach y of numlist 1991/1994 1996/1997 {
  mat res2[`y'-1990,1]=`y'
  reg lnearn ds i.age_full if pophsearn==1 & year==`y' [pw=earnwt_clean]
  mat b=e(b)
  mat res2[`y'-1990,2]=b[1,1]
  reg lnearn ds i.age_full if popcolearn==1 & year==`y' [pw=earnwt_clean]
  mat b=e(b)
  mat res2[`y'-1990,3]=b[1,1]
  }
drop _all
svmat res2, names(col)
collapse (mean) hs col, fast
mkmat hs col, matrix(res3)
mat res[2,1] = res3

*C. save
drop _all
svmat res, names(col)
gen moment=_n
lab def moment 1 "Autocorrelation of log earnings" 2 "Migrant vs. non-migrant log earnings difference"
lab values moment moment
order moment
outsheet using tabs/tab5.csv, names comma replace


log close
