SUBROUTINE CalculateStats

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

INTEGER		:: it,lcount,lq1,ist
REAL(8)		:: lw1,lw2,lw3,lw22,lw32,lw2w3
REAL(8)		:: lpa,lpb,lpAa,lpAb,lpBa,lpBb,lentropy,lentropyA,lentropyB

IF (Display>=1) write(*,*) 'Calculating stats'


Eloca = SUM(2.0-locsim, DIM=1) / REAL(nsim)
Eocca = REAL(COUNT((occsim==1), DIM=1)) / REAL(nsim)
Eoccb = REAL(COUNT((occsim==2), DIM=1)) / REAL(nsim)

Eisland_a   = REAL(COUNT((islandsim==1 .and. locsim==1), DIM=1)) / REAL(nsim)
Eisland_b   = REAL(COUNT((islandsim==1 .and. locsim==2), DIM=1)) / REAL(nsim)
Eloca_occa 	= REAL(COUNT((locsim==1 .and. occsim==1), DIM=1)) / REAL(nsim)
Eloca_occb 	= REAL(COUNT((locsim==1 .and. occsim==2), DIM=1)) / REAL(nsim)
Elocb_occa 	= REAL(COUNT((locsim==2 .and. occsim==1), DIM=1)) / REAL(nsim)
Elocb_occb 	= REAL(COUNT((locsim==2 .and. occsim==2), DIM=1)) / REAL(nsim)
Emigab 		= REAL(SUM(migabsim, DIM=1)) / REAL(nsim)
Emigba 		= REAL(SUM(migbasim, DIM=1)) / REAL(nsim)
Emig 		= REAL(SUM(migsim, DIM=1)) / REAL(nsim)
Eswitchab 	= REAL(SUM(switchabsim, DIM=1)) / REAL(nsim)
Eswitchba 	= REAL(SUM(switchbasim, DIM=1)) / REAL(nsim)
Eswitchau 	= REAL(SUM(switchausim, DIM=1)) / REAL(nsim)
Eswitchbu 	= REAL(SUM(switchbusim, DIM=1)) / REAL(nsim)
Eswitchua 	= REAL(SUM(switchuasim, DIM=1)) / REAL(nsim)
Eswitchub 	= REAL(SUM(switchubsim, DIM=1)) / REAL(nsim)
Eswitch 	= REAL(COUNT((switchabsim==1 .or. switchbasim==1), DIM=1)) / REAL(nsim)
Eunemp		= REAL(COUNT(((occsim==0) .or. (firedsim==1)), DIM=1))/REAL(Nsim)
Esearch_e	= REAL(COUNT((searchsim>0) .and. ((occsim(:,1:Ttot-1)>0) .and. (firedsim(:,1:Ttot-1)==0) ), DIM=1))/REAL(Nsim)
Esearch_u	= REAL(COUNT((searchsim>0) .and. ((occsim(:,1:Ttot-1)==0) .or. (firedsim(:,1:Ttot-1)==1) ), DIM=1))/REAL(Nsim)
Esearch_here= REAL(COUNT((searchsim==2) , DIM=1))/REAL(Nsim)	
Esearch_there= REAL(COUNT((searchsim==1) , DIM=1))/REAL(Nsim)		


Ewage_aa = 0.0
Ewage_ab = 0.0
Ewage_ba = 0.0
Ewage_bb = 0.0
Elogwage = 0.0
Elogwage2 = 0.0
Vlogwage = 0.0
Ematch_mig = 0.0

DO it = 1,Ttot
	IF(COUNT((locsim(:,it)==1 .and. occsim(:,it)==1))>0)	Ewage_aa(it)	= SUM(wsim(:,it), MASK=(locsim(:,it)==1 .and. occsim(:,it)==1)) / REAL(COUNT((locsim(:,it)==1 .and. occsim(:,it)==1)))
	IF(COUNT((locsim(:,it)==1 .and. occsim(:,it)==2))>0)	Ewage_ab(it)	= SUM(wsim(:,it), MASK=(locsim(:,it)==1 .and. occsim(:,it)==2)) / REAL(COUNT((locsim(:,it)==1 .and. occsim(:,it)==2)))
	IF(COUNT((locsim(:,it)==2 .and. occsim(:,it)==1))>0)	Ewage_ba(it)	= SUM(wsim(:,it), MASK=(locsim(:,it)==2 .and. occsim(:,it)==1)) / REAL(COUNT((locsim(:,it)==2 .and. occsim(:,it)==1)))
	IF(COUNT((locsim(:,it)==2 .and. occsim(:,it)==2))>0)	Ewage_bb(it)	= SUM(wsim(:,it), MASK=(locsim(:,it)==2 .and. occsim(:,it)==2)) / REAL(COUNT((locsim(:,it)==2 .and. occsim(:,it)==2)))
	IF(COUNT(occsim(:,it)>0)>0)	Elogwage(it) = SUM(log(wsim(:,it)), MASK=(occsim(:,it)>0)) / REAL(COUNT(occsim(:,it)>0))
	IF(COUNT(occsim(:,it)>0)>0) Elogwage2(it) = SUM(log(wsim(:,it))**2, MASK=(occsim(:,it)>0)) / REAL(COUNT(occsim(:,it)>0))
	IF(COUNT(occsim(:,it)>0)>0) Vlogwage(it) = Elogwage2(it)-Elogwage(it)**2
	IF(COUNT(islandsim(:,it)==1)>0) Equit(it)	= REAL(COUNT((occsim(:,it)==0) .and. (islandsim(:,it)==1)))/REAL(COUNT((islandsim(:,it)==1)))
	
	IF(it>1) THEN
		IF(COUNT((migsim(:,it-1)==1) .and. (occsim(:,it)==1 .or. occsim(:,it)==2))>0)	Ematch_mig(it) 	=  &
			REAL(COUNT(((occsim(:,it)==1 .and. locsim(:,it)==1) .or. (occsim(:,it)==2 .and. locsim(:,it)==2)) .and. (migsim(:,it-1)==1))) &
			/REAL(COUNT((migsim(:,it-1)==1) .and. (occsim(:,it)==1 .or. occsim(:,it)==2)))
	END IF
END DO	


! Wage distribution
! DO it=1,Ttot-1
!     wsortsim=0.0d0
!     wsortsim=wsim(:,it+1)
!     CALL quick_sort(wsortsim, worder)
!     lcount=COUNT(wsim(:,it+1)>0)
!     lq1=lcount/4
!     lw1=wsortsim(Nsim-3*lq1)
!     lw2=wsortsim(Nsim-2*lq1)
!     lw3=wsortsim(Nsim-lq1)
!     
! 	Emigq1(it)= 0.0
! 	Emigq2(it)= 0.0
! 	Emigq3(it)= 0.0
! 	Emigq4(it)= 0.0
! 	IF(COUNT((wsim(:,it+1)>0) .and. ( wsim(:,it+1)<=lw1))>0) Emigq1(it)=REAL(SUM(migsim(:,it), DIM=1, MASK=( (wsim(:,it+1)>0) .and. ( wsim(:,it+1)<=lw1)))) / REAL(COUNT((wsim(:,it+1)>0) .and. ( wsim(:,it+1)<=lw1)))
!     IF(COUNT((wsim(:,it+1)>lw1) .and. ( wsim(:,it+1)<=lw2))>0) Emigq2(it)=REAL(SUM(migsim(:,it), DIM=1, MASK=( (wsim(:,it+1)>lw1) .and. ( wsim(:,it+1)<=lw2)))) / REAL(COUNT((wsim(:,it+1)>lw1) .and. ( wsim(:,it+1)<=lw2)))
!     IF(COUNT((wsim(:,it+1)>lw2) .and. ( wsim(:,it+1)<=lw3))>0) Emigq3(it)=REAL(SUM(migsim(:,it), DIM=1, MASK=( (wsim(:,it+1)>lw2) .and. ( wsim(:,it+1)<=lw3)))) / REAL(COUNT((wsim(:,it+1)>lw2) .and. ( wsim(:,it+1)<=lw3)))
!     IF(COUNT((wsim(:,it+1)>lw3) )>0) Emigq4(it)=REAL(SUM(migsim(:,it), DIM=1, MASK=( (wsim(:,it+1)>lw3) ))) / REAL(COUNT((wsim(:,it+1)>lw3) ))
! !    Emigq2(it)=REAL(SUM(migsim(:,it), DIM=1, MASK=( (worder>Nsim-lcount+lq1) .and. ( worder<=Nsim-lcount+2*lq1)))) / REAL(lq1)
! !    Emigq3(it)=REAL(SUM(migsim(:,it), DIM=1, MASK=( (worder>Nsim-lcount+2*lq1) .and. ( worder<=Nsim-lcount+3*lq1)))) / REAL(lq1)
! !    Emigq4(it)=REAL(SUM(migsim(:,it), DIM=1, MASK=( (worder>Nsim-lcount+3*lq1) ))) / REAL(lcount-3*lq1)
! !    
!     
! !    DO ii=1,Nsim
! !        lmig(ii)=migsim(worder(ii),it)
! !    END DO
! !    Emigq1(it)=REAL(SUM(lmig(Nsim-lcount+1:Nsim-lcount+lq1)))/real(lq1)
! !    Emigq2(it)=REAL(SUM(lmig(Nsim-lcount+ lq1+1:Nsim-lcount+2*lq1)))/real(lq1)
! !    Emigq3(it)=REAL(SUM(lmig(Nsim-lcount+2*lq1+1:Nsim-lcount+3*lq1)))/real(lq1)
! !    Emigq4(it)=REAL(SUM(lmig(Nsim-lcount+3*lq1+1:Nsim)))/real(lq1)
! !    
! !    Emigq1(it)=REAL(SUM(migsim(:,it), DIM=1, MASK=( (worder>Nsim-lcount) .and. ( worder<=Nsim-lcount+lq1)))) / REAL(lq1)
! !    Emigq2(it)=REAL(SUM(migsim(:,it), DIM=1, MASK=( (worder>Nsim-lcount+lq1) .and. ( worder<=Nsim-lcount+2*lq1)))) / REAL(lq1)
! !    Emigq3(it)=REAL(SUM(migsim(:,it), DIM=1, MASK=( (worder>Nsim-lcount+2*lq1) .and. ( worder<=Nsim-lcount+3*lq1)))) / REAL(lq1)
! !    Emigq4(it)=REAL(SUM(migsim(:,it), DIM=1, MASK=( (worder>Nsim-lcount+3*lq1) ))) / REAL(lcount-3*lq1)
! !    
! END DO

Ewage_mig = 0.0
Ewage_non = 0.0
Elogwage_mig = 0.0
Elogwage_non = 0.0
Eunemp_mig = 0.0
Eunemp_non = 0.0
DO it = 2,Ttot
	IF(COUNT((migsim(:,it-1)==1) .and. (occsim(:,it)>0))>0) Ewage_mig(it)	= SUM(wsim(:,it), MASK=((migsim(:,it-1)==1) .and. (occsim(:,it)>0))) / REAL(COUNT((migsim(:,it-1)==1) .and. (occsim(:,it)>0)))
	IF(COUNT((migsim(:,it-1)==0) .and. (occsim(:,it)>0))>0) Ewage_non(it)	= SUM(wsim(:,it), MASK=((migsim(:,it-1)==0) .and. (occsim(:,it)>0))) / REAL(COUNT((migsim(:,it-1)==0) .and. (occsim(:,it)>0)))
	IF(COUNT((migsim(:,it-1)==1) .and. (occsim(:,it)>0))>0) Elogwage_mig(it)	= SUM(log(wsim(:,it)), MASK=((migsim(:,it-1)==1) .and. (occsim(:,it)>0))) / REAL(COUNT((migsim(:,it-1)==1) .and. (occsim(:,it)>0)))
	IF(COUNT((migsim(:,it-1)==0) .and. (occsim(:,it)>0))>0) Elogwage_non(it)	= SUM(log(wsim(:,it)), MASK=((migsim(:,it-1)==0) .and. (occsim(:,it)>0))) / REAL(COUNT((migsim(:,it-1)==0) .and. (occsim(:,it)>0)))
    IF(COUNT(migsim(:,it-1)==1)>0) Eunemp_mig(it)	= REAL(COUNT(((occsim(:,it)==0) .or. (firedsim(:,it)==1)) .and. (migsim(:,it-1)==1))) / REAL(COUNT(migsim(:,it-1)==1))
    IF(COUNT(migsim(:,it-1)==0)>0) Eunemp_non(it)	= REAL(COUNT(((occsim(:,it)==0) .or. (firedsim(:,it)==1)) .and. (migsim(:,it-1)==0))) / REAL(COUNT(migsim(:,it-1)==0))
END DO

DO it = 1,Ttot-2
	IF(COUNT(migsim(:,it)==1)>0) Eretmig1(it) = REAL(COUNT(migsim(:,it)==1 .and. (locsim(:,it) == locsim(:,it+2)))) / REAL(COUNT(migsim(:,it)==1))
END DO
DO it = 1,Ttot-3
	IF(COUNT(migsim(:,it)==1)>0) Eretmig2(it) = REAL(COUNT(migsim(:,it)==1 .and. (locsim(:,it) == locsim(:,it+3)))) / REAL(COUNT(migsim(:,it)==1))
END DO
DO it = 1,Ttot-6
	IF(COUNT(migsim(:,it)==1)>0) Eretmig5(it) = REAL(COUNT(migsim(:,it)==1 .and. (locsim(:,it) == locsim(:,it+6)))) / REAL(COUNT(migsim(:,it)==1))
END DO

DO it = 1,Ttot-1
	Emig1(it) = REAL(COUNT(locsim(:,it) .ne. locsim(:,it+1))) / REAL(nsim)
END DO
DO it = 1,Ttot-2
	Emig2(it) = REAL(COUNT(locsim(:,it) .ne. locsim(:,it+2))) / REAL(nsim)
END DO
DO it = 1,Ttot-5
	Emig5(it) = REAL(COUNT(locsim(:,it) .ne. locsim(:,it+5))) / REAL(nsim)
END DO

Eu_mig = 0.0
Emig_e = 0.0
Emig_u = 0.0
DO it = 1,Ttot-1
	! fraction of migrants who are unemployed (after arrivinb)
	IF(COUNT((migsim(:,it)==1), DIM=1)>0) Eu_mig(it) = REAL(COUNT((occsim(:,it+1)==0) .and. (migsim(:,it)==1), DIM=1))/REAL(COUNT((migsim(:,it)==1)))
	!Migration rate for U/E
	IF(COUNT(occsim(:,it+1)>0)>0)	Emig_e(it)	= REAL(COUNT((occsim(:,it+1)>0) .and. (migsim(:,it)==1)))/REAL(COUNT(occsim(:,it+1)>0))
	IF(COUNT(occsim(:,it+1)==0)>0)	Emig_u(it)	= REAL(COUNT((occsim(:,it+1)==0) .and. (migsim(:,it)==1)))/REAL(COUNT((occsim(:,it+1)==0)))
END DO


!overall statistics for calibration

IF(CalibrateFirstPeriod==1) ist = 1
IF(CalibrateFirstPeriod==0) ist = 2

AGGmignonlogwagediff = 0.0
IF(SUM(Emig(ist:ist+nage-1))>0) AGGmignonlogwagediff = sum((Elogwage_mig(ist+1:ist+1+nage-1)-Elogwage_non(ist+1:ist+1+nage-1))*Emig(ist:ist+nage-1)*(1-Emig(ist:ist+nage-1))) / sum(Emig(ist:ist+nage-1)*(1-Emig(ist:ist+nage-1)))

lw2 = SUM(log(wsim(:,ist:ist+nage-1)), MASK=(occsim(:,ist:ist+nage-1)>0 .and. occsim(:,ist+1:ist+1+nage-1)>0)) / REAL(COUNT(occsim(:,ist:ist+nage-1)>0 .and. occsim(:,ist+1:ist+1+nage-1)>0))
lw3 = SUM(log(wsim(:,ist+1:ist+1+nage-1)), MASK=(occsim(:,ist:ist+nage-1)>0 .and. occsim(:,ist+1:ist+1+nage-1)>0)) / REAL(COUNT(occsim(:,ist:ist+nage-1)>0 .and. occsim(:,ist+1:ist+1+nage-1)>0))
lw22 = SUM(log(wsim(:,ist:ist+nage-1))**2, MASK=(occsim(:,ist:ist+nage-1)>0 .and. occsim(:,ist+1:ist+1+nage-1)>0)) / REAL(COUNT(occsim(:,ist:ist+nage-1)>0 .and. occsim(:,ist+1:ist+1+nage-1)>0))
lw32 = SUM(log(wsim(:,ist+1:ist+1+nage-1))**2, MASK=(occsim(:,ist:ist+nage-1)>0 .and. occsim(:,ist+1:ist+1+nage-1)>0)) / REAL(COUNT(occsim(:,ist:ist+nage-1)>0 .and. occsim(:,ist+1:ist+1+nage-1)>0))
lw2w3 = SUM(log(wsim(:,ist:ist+nage-1))*log(wsim(:,ist+1:ist+1+nage-1)), MASK=(occsim(:,ist:ist+nage-1)>0 .and. occsim(:,ist+1:ist+1+nage-1)>0)) / REAL(COUNT(occsim(:,ist:ist+nage-1)>0 .and. occsim(:,ist+1:ist+1+nage-1)>0))

AGGautocorrlogwage = (lw2w3 - lw2*lw3) /sqrt((lw22-lw2**2)*(lw32-lw3**2))

AGGmatchlococc = 0.0
IF(COUNT(occsim(:,ist+1:ist+1+nage-1)>0)>0) AGGmatchlococc = COUNT((locsim(:,ist+1:ist+1+nage-1)==1 .and. occsim(:,ist+1:ist+1+nage-1)==1) .or. (locsim(:,ist+1:ist+1+nage-1)==2 .and. occsim(:,ist+1:ist+1+nage-1)==2)) &
					/ REAL(COUNT(occsim(:,ist+1:ist+1+nage-1)>0))

AGGoccswitchrate = 1.0	!NOT READY YET

AGGretmigrate = 0.0
IF(COUNT(migsim(:,2:0+nage-1)==1)>0) AGGretmigrate = REAL(COUNT(migsim(:,2:0+nage-1)==1 .and. (locsim(:,2:0+nage-1) == locsim(:,4:2+nage-1)))) / REAL(COUNT(migsim(:,2:0+nage-1)==1))

!thiel index: only used employed workers
lpa = COUNT(occsim(:,ist+1:ist+1+nage-1)==1) / REAL(COUNT(occsim(:,ist+1:ist+1+nage-1)>0))
lpb = COUNT(occsim(:,ist+1:ist+1+nage-1)==2) / REAL(COUNT(occsim(:,ist+1:ist+1+nage-1)>0))
lentropy = -(lpa*log(lpa) + lpb*log(lpb))

lpAa = COUNT(locsim(:,ist+1:ist+1+nage-1)==1 .and. occsim(:,ist+1:ist+1+nage-1)==1) / REAL(COUNT(locsim(:,ist+1:ist+1+nage-1)==1 .and. occsim(:,ist+1:ist+1+nage-1)>0))
lpAb = COUNT(locsim(:,ist+1:ist+1+nage-1)==1 .and. occsim(:,ist+1:ist+1+nage-1)==2) / REAL(COUNT(locsim(:,ist+1:ist+1+nage-1)==1 .and. occsim(:,ist+1:ist+1+nage-1)>0))
lentropyA = -(lpAa*log(lpAa) + lpAb*log(lpAb))

lpBa = COUNT(locsim(:,ist+1:ist+1+nage-1)==2 .and. occsim(:,ist+1:ist+1+nage-1)==1) / REAL(COUNT(locsim(:,ist+1:ist+1+nage-1)==2 .and. occsim(:,ist+1:ist+1+nage-1)>0))
lpBb = COUNT(locsim(:,ist+1:ist+1+nage-1)==2 .and. occsim(:,ist+1:ist+1+nage-1)==2) / REAL(COUNT(locsim(:,ist+1:ist+1+nage-1)==2 .and. occsim(:,ist+1:ist+1+nage-1)>0))
lentropyB = -(lpBa*log(lpBa) + lpBb*log(lpBb))

AGGthiel = 1 - (lentropyA + lentropyB)/(2.0*lentropy)

!reasons for moving
IF(SUM(Emig(2:2+nage-1))>0) THEN
	AGGreason1amenity 	=  COUNT(reason1sim(:,ist:ist+nage-1)==1) / REAL(COUNT(migsim(:,ist:ist+nage-1)==1))
	AGGreason1labor 	=  COUNT(reason1sim(:,ist:ist+nage-1)==2) / REAL(COUNT(migsim(:,ist:ist+nage-1)==1))
	AGGreason2amenity 	=  COUNT(reason2sim(:,ist:ist+nage-1)==1) / REAL(COUNT(migsim(:,ist:ist+nage-1)==1))
	AGGreason2labor 	=  COUNT(reason2sim(:,ist:ist+nage-1)==2) / REAL(COUNT(migsim(:,ist:ist+nage-1)==1))
END IF

IF(Display>=1 .and. DoCalibration==0) THEN !
	write(*,*) '____________________________'
	write(*,*) "Gross migration rate, including t=1	", sum(Emig(1:Ttot-1))/real(Ttot-1)
	write(*,*) "Gross migration rate, not including t=1	", sum(Emig(2:Ttot-1))/real(Ttot-2)
	write(*,*) "Fraction who ever migrate	", sum(evermigsim)/real(nsim)
	write(*,*) "Av number lifetime moves	", sum(nmovesim)/real(nsim)
	IF(count(nmovesim>0)>0) write(*,*) "Av number lifetime moves, positive", sum(nmovesim, mask = nmovesim>0)/real(count(nmovesim>0))
	IF(count(migsim(:,1:Ttot-2)>0)) write(*,*) "1yr return migration rate", REAL(COUNT(migsim(:,1:Ttot-2)==1 .and. (locsim(:,1:Ttot-2) == locsim(:,3:Ttot)))) / REAL(COUNT(migsim(:,1:Ttot-2)==1))
	IF(count(migsim(:,1:Ttot-2)>0)) write(*,*) "2yr return migration rate", REAL(COUNT(migsim(:,1:Ttot-3)==1 .and. (locsim(:,1:Ttot-3) == locsim(:,4:Ttot)))) / REAL(COUNT(migsim(:,1:Ttot-3)==1))
	IF(count(migsim(:,1:Ttot-2)>0)) write(*,*) "5yr return migration rate", REAL(COUNT(migsim(:,1:Ttot-6)==1 .and. (locsim(:,1:Ttot-6) == locsim(:,7:Ttot)))) / REAL(COUNT(migsim(:,1:Ttot-6)==1))
	
	write(*,*) "Mig-non wage difference, controling for age", sum((Ewage_mig(2:Ttot)-Ewage_non(2:Ttot))*Emig*(1-Emig)) / sum(Emig*(1-Emig))
	write(*,*) "Mig-non wage difference, not controling for age", sum( Ewage_mig(2:Ttot)-Ewage_non(2:Ttot)) / REAL(Ttot-1)
	write(*,*) "Mig-non log wage difference, controling for age", sum((Elogwage_mig(2:Ttot)-Elogwage_non(2:Ttot))*Emig*(1-Emig)) / sum(Emig*(1-Emig))
	write(*,*) "Mig-non log wage difference, not controling for age", sum( Elogwage_mig(2:Ttot)-Elogwage_non(2:Ttot)) / REAL(Ttot-1)
	write(*,*) "Mig-non employment difference, controling for age", sum((Eunemp_non(2:Ttot)-Eunemp_mig(2:Ttot))*Emig*(1-Emig)) / sum(Emig*(1-Emig))
	write(*,*) "Mig-non employment difference, not controling for age", sum( Eunemp_non(2:Ttot)-Eunemp_mig(2:Ttot)) / REAL(Ttot-1)
	write(*,*) "Overall unemployment rate" , sum(Eunemp)/REAL(Ttot)
	write(*,*) "Thiel Index" , AGGthiel
	write(*,*) "Fraction migrate for labor reasons, defn 1 " , AGGreason1labor
	write(*,*) "Fraction migrate for labor reasons, defn 2 " , AGGreason2labor
	write(*,*) "Auto correlation log wages " , AGGautocorrlogwage
	
	write(*,*) '____________________________'
! 	write(*,*) "Unemployed, search: "
! 	write(*,*) real(count((islandsim(:,1:Ttot-1)==0) .and. ( searchsim>0)  , dim=1))/real(count((islandsim(:,1:Ttot-1)==0) , dim=1))
    !write(*,*) "unemployed, search, found", real(count((islandsim(:,1:Ttot-1)==0) .and. ( searchsim>0) .and. ((offersim(:,1:ttot-1,1)==1 ) .or. (offersim(:,1:ttot-1,2)==1)) , dim=1))/real(count((islandsim(:,1:Ttot-1)==0) .and. ( searchsim>0), dim=1))
	!write(*,*) "employed, search ", real(count((occsim(:,1:Ttot-1)>0) .and. ( searchsim>0)  , dim=1))/real(count((occsim(:,1:Ttot-1)>0) , dim=1))
    !write(*,*) "employed, search, found", real(count((occsim(:,1:Ttot-1)>0) .and. ( searchsim>0) .and. ((offersim(:,1:ttot-1,1)==1 ) .and. (offersim(:,1:ttot-1,2)==1)) , dim=1))/real(count((occsim(:,1:Ttot-1)>0) .and. ( searchsim>0), dim=1))
	write(*,*) '____________________________'
! write(*,*) "ma", Mgrid( gPoints(4,1),gPoints(2,1) ,1)

!write(*,*) "Unemployment" , real(sum(Eunemp))/real(Ttot)
!write(*,*) "Fired" , REAL(COUNT((occsim(:,5)>0) .and. (firedsim(:,5)==1)))/REAL(COUNT(occsim(:,5)>0))
!write(*,*) "Fired" , REAL(COUNT((occsim(:,15)>0) .and. (firedsim(:,15)==1)))/REAL(COUNT(occsim(:,15)>0))

!	write(*,*) 'Some checks'
!	write(*,*) "Initial unemployment" , REAL(COUNT(islandsim(:,1)==0))/REAL(Nsim)
!	write(*,*) "Unemployment at the end of t=1" ,  REAL(COUNT(occsim(:,1)==0))/REAL(Nsim)
!	write(*,*) "Employed at t=1, migrated to a place w/o offer" , REAL(COUNT(occsim(:,1)>0 .and. migsim(:,1)==1 .and. islandsim(:,2)==0))/REAL(Nsim)
!	write(*,*) "Not in island at t=2" , REAL(COUNT(islandsim(:,2)==0))/REAL(Nsim)
!	write(*,*) "Migrated w/o offer and did not search (t=1,2)" ,  REAL(COUNT( migsim(:,1)==1 .and. islandsim(:,2)==0 .and. searchsim(:,2)==0))/REAL(Nsim)
!	write(*,*) "No offer(not in island) and searched in same location (t=2)" ,  REAL(COUNT(islandsim(:,2)==0 .and. searchsim(:,2)==2))/REAL(Nsim)
!	write(*,*) "Out of the ones above, got an offer" ,  REAL(COUNT(islandsim(:,2)==0 .and. searchsim(:,2)==2 .and. (offersim(:,2,1)==1 .or. offersim(:,2,2)==1)))/REAL(Nsim)
!    write(*,*) "Out of the same group, now on island" ,  REAL(COUNT(islandsim(:,2)==0 .and. searchsim(:,2)==2 .and. islandsim(:,3)==1))/REAL(Nsim)
!	write(*,*) "No offer(not in island) and searched in other location (t=2)" ,  REAL(COUNT(islandsim(:,2)==0 .and. searchsim(:,2)==1))/REAL(Nsim)
!	write(*,*) "Out of the ones above, got an offer" ,  REAL(COUNT(islandsim(:,2)==0 .and. searchsim(:,2)==1 .and. (offersim(:,2,1)==1 .or. offersim(:,2,2)==1)))/REAL(Nsim)
!	write(*,*) "Out of the same group, now on island" ,  REAL(COUNT(islandsim(:,2)==0 .and. searchsim(:,2)==1 .and. islandsim(:,3)==1))/REAL(Nsim)
!	
	!write(*,*) "Fraction of employed with at least 1 offer. Should be 100% " , REAL(COUNT(occsim(:,2)>0 .and. (offersim(:,2,1)==1 .or. offersim(:,2,2)==1)) )/REAL(COUNT(occsim(:,2)>0))
    !write(*,*) "Fraction of employed who searched and two offers " , REAL(COUNT(occsim(:,2)>0 .and. offersim(:,2,1)==1 .and. offersim(:,2,2)==1 .and. searchsim(:,2)>0) )/REAL(COUNT(occsim(:,2)>0 .and. searchsim(:,2)>0))

END IF

END SUBROUTINE CalculateStats