SUBROUTINE GraphRegions

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE
! Dictionary, create variables to store



integer                             :: ip, lt, lsa,lma, lna, li, is,im,lcount,lmig, lmig0, lmig1, lmig2, lsearch(1)
real(8)                             :: lJhere(0:1), lJthere(0:1), lEVhere(0:1), lEVthere(0:1), lindx(0:2,0:2)
real(8)                             :: lss, lsm, lH(0:2), lL(0:1,0:1),lpointsr(2,gNg)

!*************************************************************************!
! The number of graphs (gNg) and the points used for the graphs (gPoints)
! are read from text files that should be in the Input folder. They are
! read in the "Set parameters" module.

! The parameter gNgr is the upperbound for gNg
!*************************************************************************!



!mig/search options
lindx(0,0)=1 !no migration, no search
lindx(2,0)=2 !migrate, no search 
lindx(1,1)=3 !migrate only if offer, search there
lindx(2,1)=4 !migrate regardless, search there
lindx(0,2)=5 !no migration regardless, search here
lindx(1,2)=6 !migrate if no offer(here), search here
lindx(1,0)=7 !migrate conditional on offer, but no search (not defined)
!these ones should never show
lindx(0,1)=8 ! no migration regardless, but search there (suboptimal)
lindx(2,2)=9 ! migrate regardless, but search here(suboptimal)

! loop over the different combinations of the state space

IF (gNg>gNgr) write(*,*) "Maximum number of graphs is", gNgr
DO ip=1,gNg
    lsa=gPoints(1,ip)
    lma=gPoints(2,ip)
    lt=gPoints(3,ip)
    lna=gPoints(4,ip)
    li=gPoints(5,ip)
    lss=(Sgrid(lt,Ns)-Sgrid(lt,1))/real(gNs-1)
    lsm=(Mgrid(lt-lna,Nm,2)-Mgrid(lt-lna,1,2))/real(gNm-1)    
    lcount=0
    lPointsr(1,ip)=Sgrid(lt,lsa)
    lPointsr(2,ip)=Mgrid(lna,lma,1)
    DO is=1,gNs
        DO im=1,gNm
            lcount=lcount+1
            gsb(lcount,ip)=Sgrid(lt,1)+real(is)*lss
            gmb(lcount,ip)=Mgrid(lt-lna,1,2)+real(im)*lsm
            
            IF (li==1) THEN !Employed
                
                
                !Continuation Value of NM
    	       CALL BiLinInterp1 (Ns,Sgrid(lt,:),Nm, Mgrid(lt-lna,:,2),EV(2,lt+1,lna+1,lsa,:,lma,:),gsb(lcount,ip),gmb(lcount,ip),lEVhere(1))
			   
			    !Continuation value of migrating
			      !If offer
			   CALL BiLinInterp1 (Ns,Sgrid(lt,:),Nm, Mgrid(lt-lna,:,2),EV(4,lt+1,lna,lsa,:,lma,:),gsb(lcount,ip),gmb(lcount,ip),lEVthere(1))
    	          ! No offer
    	       CALL BiLinInterp1 (Ns,Sgrid(lt,:),Nm, Mgrid(lt-lna,:,2),EV(3,lt+1,lna,lsa,:,lma,:),gsb(lcount,ip),gmb(lcount,ip),lEVthere(0))  
    			
    			!Migration decision	
	            lJhere(1)= Mgrid(lna,lma,1) + bet*lEVhere(1) 
                lJthere(0)=-kappa+ gmb(lcount,ip) +bet*lEVthere(0)
                lJthere(1)=-kappa+ gmb(lcount,ip) +bet*lEVthere(1)
                
                IF (lJthere(0)>lJhere(1)) THEN
                    lmig=2
                ELSE IF (lJthere(1)>lJhere(1)) THEN
                    lmig=1

                ELSE 
                    lmig=0
	            END IF
	            
	            !Search decision
                lL(1,1)=MAXVAL((/lJthere(1), lJhere(1)/))
                lL(1,0)=MAXVAL((/lJthere(0), lJhere(1)/))
                
                lH(0)=lL(1,0)
                lH(1)=lambda_e*lL(1,1)+(1.0d0-lambda_e)*lH(0)-c_e
                lsearch=MAXLOC(lH(0:1))-1
                
                gsearchmig(lcount, ip)=lindx(lmig, lsearch(1))
                
                !Occupation decision threshold
                gSth(ip)=Sgrid(lt,lsa)/theta
                
            ELSE IF (li==0) THEN !Unemployed
               !Continuation Value of NM
                    !If offer
    	       CALL BiLinInterp1 (Ns,Sgrid(lt,:),Nm, Mgrid(lt-lna,:,2),EV(2,lt+1,lna+1,lsa,:,lma,:),gsb(lcount,ip),gmb(lcount,ip),lEVhere(1))
			        ! No offer
			   CALL BiLinInterp1 (Ns,Sgrid(lt,:),Nm, Mgrid(lt-lna,:,2),EV(1,lt+1,lna+1,lsa,:,lma,:),gsb(lcount,ip),gmb(lcount,ip),lEVhere(0))
			    !Continuation value of migrating
			      !If offer
			   CALL BiLinInterp1 (Ns,Sgrid(lt,:),Nm, Mgrid(lt-lna,:,2),EV(4,lt+1,lna,lsa,:,lma,:),gsb(lcount,ip),gmb(lcount,ip),lEVthere(1))
    	          ! No offer
    	       CALL BiLinInterp1 (Ns,Sgrid(lt,:),Nm, Mgrid(lt-lna,:,2),EV(3,lt+1,lna,lsa,:,lma,:),gsb(lcount,ip),gmb(lcount,ip),lEVthere(0))  
    			
                !Migration decision
                lJhere(1)= Mgrid(lna,lma,1) + bet*lEVhere(1) 
                lJhere(0)= Mgrid(lna,lma,1) + bet*lEVhere(0) 
                lJthere(0)=-kappa+ gmb(lcount,ip) +bet*lEVthere(0)
                lJthere(1)=-kappa+ gmb(lcount,ip) +bet*lEVthere(1)
                
                ! For the case when the search was there
                IF (lJthere(0)>lJhere(0)) THEN
                    lmig1=2 !M regardless
                ELSEIF (lJthere(1)>lJhere(0)) THEN
                    lmig1=1 !M only if offer
                ELSE 
                    lmig1=0 !Never M (this one should not happen if search was made)
                END IF
                
                ! When search was here
                IF (lJhere(0)>=lJthere(0)) THEN
                    lmig2=0 !Stay (NM) regardless
                ELSEIF (lJhere(1)>=lJthere(0)) THEN
                    lmig2=1 !Stay  if offer (from here)/ migrate if no offer
                ELSE 
                    lmig2=2    !Always Migrate (this one should never happen if search was made)
                END IF
                !If no search
                IF (lJhere(0)>=lJthere(0)) THEN
                    lmig0=0 !Stay 
                ELSE 
                    lmig0=2 !Migrate
                END IF
                lL(1,1)=MAXVAL((/lJthere(1), lJhere(1)/))
                lL(1,0)=MAXVAL((/lJthere(0), lJhere(1)/))
                lL(0,1)=MAXVAL((/lJthere(1), lJhere(0)/))
                lL(0,0)=MAXVAL((/lJthere(0), lJhere(0)/))
                !Search decision
                lH(0)=lL(0,0)
                lH(1)=lambda_u1*lL(0,1)+(1.0d0-lambda_u1)*lH(0)-c_u1
                lH(2)=lambda_u2*lL(1,0)+(1.0d0-lambda_u2)*lH(0)-c_u2
                lsearch=MAXLOC(lH)-1
                
                IF (lsearch(1)==0) gsearchmig(lcount, ip)=lindx(lmig0, lsearch(1))
                IF (lsearch(1)==1) gsearchmig(lcount, ip)=lindx(lmig1, lsearch(1))
                IF (lsearch(1)==2) gsearchmig(lcount, ip)=lindx(lmig2, lsearch(1))
                
            END IF

        END DO
    END DO
END DO

! Save the results
OPEN(3, FILE = trim(OutputDir) // '/graph_regions_sb.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,gNs*gNm,gNg,gsb(:,1:gNg))
OPEN(3, FILE = trim(OutputDir) // '/graph_regions_mb.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,gNs*gNm,gNg,gmb(:,1:gNg))
OPEN(3, FILE = trim(OutputDir) // '/graph_regions_searchmig.txt', STATUS = 'replace'); CALL WriteMatrixInteger(3,gNs*gNm,gNg,gsearchmig(:,1:gNg))
OPEN(3, FILE = trim(OutputDir) // '/graph_regions_points.txt', STATUS = 'replace'); CALL WriteMatrixInteger(3,5,gNg,gPoints(:,1:gNg))
OPEN(3, FILE = trim(OutputDir) // '/graph_regions_occ.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,gNg,1,gSth(1:gNg))
OPEN(3, FILE = trim(OutputDir) // '/graph_regions_pointsR.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,2,gNg,lPointsr)

END SUBROUTINE GraphRegions