SUBROUTINE Grids

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

INTEGER 		:: im,it,ij,in,ima,imb,isa,isb
REAL(8) 		:: lxa, lxb, lxc,lfa,lfb,lfc,lfval,lm,lghnodes(Nz),lghweights(Nz),lmgridpar,lvarm ,lt
REAL(8), EXTERNAL           :: GOLDEN, FnGridPref



IF(Display>=1) write(*,*) 'Constructing grids'

!Zgrid quadrature points
CALL mherzo(Nz,lghnodes,lghweights)
Zgrid   = exp(sqrt(2.0)*lghnodes)
Zprob   = lghweights/sum(lghweights)


!Mgrid beliefs
lmgridpar = 2.0
DO in=0,Ttot
	lvarM = 1.0/tauV + 1.0/(tau0+real(in)*tauE)
    DO ij=1,Nj
    DO im=1,Nm
        Mgrid(in,im,ij)=  - lmgridpar*SQRT(lvarM) + REAL((im-1))*(lmgridpar*2.0*SQRT(lvarM))/REAL((Nm-1))
    END DO
    END DO
END DO

!S grid 
varS(1) = vS0
DO it = 2, Ttot+1
	varS(it) = (rhos**2)*varS(it-1) + Veta
END DO 


! Non stationary grid (looking for the optimal "width")
lxa = 1.0e-8
lxb = 1.5
CALL MNBRAK(lxa,lxb,lxc,lfa,lfb,lfc,FnGridPref)
lfval = GOLDEN(lxa,lxb,lxc,FnGridPref,1.0e-3_8,lm)
lfval = FnGridPref(lm)
IF(Display>=3) write(*,*) "width of S grid = +-", lm ,"std.dev."

!Adjust so that E(S)=1 for all t, and build S.
DO it=1,Ttot+1
    Sgrid(it,:) = exp(logSgrid(it, :))
!     Sgrid(it,:) = Sgrid(it, :)/DOT_PRODUCT(Sgrid(it,:), Sdist(it,:))
END DO


!age-profile for wages
DO it=1,Ttot+1
	lt = real(it)
	phi(it) = exp(alpha0+alpha1*lt+alpha2*cheby2(lt))
END DO


ij = 0
DO ima = 1, Nm
DO imb = 1, Nm
DO isa = 1, Ns
DO isb = 1, Ns
	ij = ij + 1
	maind(ij) = ima
	mbind(ij) = imb
	saind(ij) = isa
	sbind(ij) = isb
END DO
END DO
END DO
END DO

jind(1)=1
jind(2)=1
jind(3)=2
jind(4)=2

iind(1)=0
iind(2)=1
iind(3)=0
iind(4)=1


END SUBROUTINE Grids
