SUBROUTINE MomentConditions(lnpar,ly,lf,lfvec)

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

INTEGER, INTENT(IN)     				:: lnpar
REAL(8), DIMENSION(lnpar), INTENT(IN)  	:: ly
REAL(8), INTENT(OUT) 					:: lf,lfvec(nmoments)
INTEGER     	:: ip,ist
REAL(8)			:: lx(lnpar),lJ

lx = ly/paramscale
! write(*,*) 'lx is: ',lx

write(4,*) '*********************************'
write(4,*) 'EVALUATION NUMBER: ',objeval

!Extract parameters
ip = 0
IF(ChooseKappa==1) THEN
    ip=ip+1
	kappa = exp(lx(ip))
	write(4,*) ' kappa guess: ',kappa
END IF

IF(ChooseTau0==1) THEN
    ip=ip+1
	tau0 = exp(lx(ip))
	write(4,*) ' tau0 guess: ',tau0
END IF

IF(ChooseTauE==1) THEN
    ip=ip+1
	tauE = exp(lx(ip))
	write(4,*) ' tauE guess: ',tauE
END IF

IF(ChooseTauV==1) THEN
	ip = ip+1
	tauV = exp(lx(ip))
	write(4,*) ' tauV guess: ',tauV
END IF

IF(ChooseTheta==1) THEN
    ip=ip+1
	theta = logistic(lx(ip))
	write(4,*) ' theta guess: ',theta
END IF

IF(ChooseVS0==1) THEN
    ip=ip+1
	vS0 = exp(lx(ip))
	write(4,*) ' vS0 guess: ',vS0
END IF

IF(ChooseVEta==1) THEN
	ip=ip+1
	veta = exp(lx(ip))
	write(4,*) ' veta guess: ',veta
END IF

IF(ChooseRhoS==1) THEN
	ip=ip+1
	rhoS = logistic(lx(ip))
	write(4,*) ' rhoS guess: ',rhoS
END IF

IF(ChooseLambdaE==1) THEN
	ip=ip+1
	lambda_e = logistic(lx(ip))
	write(4,*) ' lambda_e guess: ',lambda_e
END IF

IF(ChooseLambdaU1==1) THEN
	ip=ip+1
	lambda_u1 = logistic(lx(ip))
	write(4,*) ' lambda_u1 guess: ',lambda_u1
END IF

IF(ChooseLambdaU2==1) THEN
	ip=ip+1
	lambda_u2 = logistic(lx(ip))
	write(4,*) ' lambda_u2 guess: ',lambda_u2
END IF

IF(ChooseCostE==1) THEN
	ip=ip+1
	c_e = exp(lx(ip))
	write(4,*) ' c_e guess: ',c_e
END IF

IF(ChooseCostU1==1) THEN
	ip=ip+1
	c_u1 = exp(lx(ip))
	write(4,*) ' c_u1 guess: ',c_u1
END IF

IF(ChooseCostU2==1) THEN
	ip=ip+1
	c_u2 = exp(lx(ip))
	write(4,*) ' c_u2 guess: ',c_u2
END IF

IF(ChooseBen==1) THEN
	ip=ip+1
	ben = exp(lx(ip))
	write(4,*) ' ben guess: ',ben
END IF

IF(ChooseU0==1) THEN
	ip=ip+1
	u_0 = logistic(lx(ip))
	write(4,*) ' u_0 guess: ',u_0
END IF

IF(ChooseAlpha0==1) THEN
	ip=ip+1
	alpha0 = lx(ip)
	write(4,*) ' alpha0 guess: ',alpha0
END IF

IF(ChooseQuadWageProf==1) THEN

	ip=ip+1
	alpha1 = lx(ip)
	write(4,*) ' alpha1 guess: ',alpha1

	ip=ip+1
	alpha2 = lx(ip)
	write(4,*) ' alpha2 guess: ',alpha2
END IF

IF(ChooseDelta==1) THEN
	ip=ip+1
	delta = logistic(lx(ip))
	write(4,*) ' delta guess: ',delta
END IF

IF(ChooseBias==1) THEN
	ip=ip+1
	bias = lx(ip)
	write(4,*) ' bias guess: ',bias
END IF

IF(ChooseTau0Bias==1) THEN
	ip=ip+1
	tau0bias = logistic(lx(ip))
	write(4,*) ' tau0bias guess: ',tau0bias
END IF
  
!Solve Model
IF(Display>=1) write(*,*) '**************************************************'
CALL Grids
CALL Decisions
CALL Simulations
CALL CalculateStats

!moments to match: need to include weights
write(4,*) ' -~-~-~-~-~'
ip = 0

IF(CalibrateFirstPeriod==1) ist = 1
IF(CalibrateFirstPeriod==0) ist = 2

IF (MatchAgeProfileMig == 1) THEN
	lfvec(1:nage) = Emig(ist:ist+nage-1) - dataEmig	!start at 2 because mig(2) means moved between 2 and 3
	IF(UseDiagWeight==1) diagweight(1:nage) = RelativeWgtMigration*nage/(sum(dataEmig)**2)
	write(4,*) ' av migration',sum(dataEmig)/real(nage),sum(Emig(ist:ist+nage-1))/real(nage)
	ip = ip + nage
END IF

IF (MatchAgeProfileUnemp == 1) THEN
	lfvec(ip+1:ip+nage) = Eunemp(ist+1:ist+1+nage-1) - dataEunemp
	IF(UseDiagWeight==1) diagweight(ip+1:ip+nage) = RelativeWgtAgeMom*nage/(sum(dataEunemp)**2)	
	write(4,*) ' av unemp',sum(dataEunemp)/real(nage),sum(Eunemp(ist+1:ist+1+nage-1))/real(nage)
	ip = ip + nage
END IF

IF (MatchAgeProfileMeanLogWage == 1) THEN 
	lfvec(ip+1:ip+nage) = Elogwage(ist+1:ist+1+nage-1) - dataElogwage
	IF(UseDiagWeight==1) diagweight(ip+1:ip+nage-1) = RelativeWgtAgeMom*nage/(sum(dataElogwage)**2)	
	write(4,*) ' av mean log wage',sum(dataElogwage)/real(nage),sum(Elogwage(ist+1:ist+1+nage-1))/real(nage)
	ip = ip + nage
END IF

IF (MatchAgeProfileVarLogWage == 1) THEN
	lfvec(ip+1:ip+nage) = Vlogwage(ist+1:ist+1+nage-1) - dataVlogwage
	IF(UseDiagWeight==1) diagweight(ip+1:ip+nage) = RelativeWgtAgeMom*nage/(sum(dataVlogwage)**2)		
	write(4,*) ' av var log wage',sum(dataVlogwage)/real(nage),sum(Vlogwage(ist+1:ist+1+nage-1))/real(nage)
	ip = ip + nage
END IF

IF (MatchLogWageMigNonDiff == 1) THEN
	lfvec(ip+1) = AGGmignonlogwagediff - dataAGGmignonlogwagediff
	IF(UseDiagWeight==1) diagweight(ip+1) = 1.0/(WeightValLogWageMigNonDiff**2)	
	write(4,*) ' mig-non log wage diff',dataAGGmignonlogwagediff,AGGmignonlogwagediff
	ip = ip + 1
END IF

IF (MatchFracMatchedOccLoc == 1) THEN
	lfvec(ip+1) = AGGmatchlococc - dataAGGmatchlococc
	IF(UseDiagWeight==1) diagweight(ip+1) = 1.0/(dataAGGmatchlococc**2)
	write(4,*) ' frac matched loc occ',dataAGGmatchlococc,AGGmatchlococc
	ip = ip + 1
END IF

IF (MatchOccSwitchRate == 1) THEN
	lfvec(ip+1) = AGGoccswitchrate - dataAGGoccswitchrate
	IF(UseDiagWeight==1) diagweight(ip+1) = 1.0/(dataAGGoccswitchrate**2)
	write(4,*) ' occ switch rate',dataAGGoccswitchrate,AGGoccswitchrate
	ip = ip + 1
END IF

IF (MatchReturnMigRate == 1) THEN
	lfvec(ip+1) = AGGretmigrate - dataAGGretmigrate
	IF(UseDiagWeight==1) diagweight(ip+1) = 1.0/(dataAGGretmigrate**2)
	write(4,*) ' return mig rate',dataAGGretmigrate,AGGretmigrate
	ip = ip + 1
END IF

IF (MatchAutoCorrLogWage == 1) THEN
	lfvec(ip+1) = AGGautocorrlogwage - dataAGGautocorrlogwage
	IF(UseDiagWeight==1) diagweight(ip+1) = RelativeWgtAutoCorrLogWage/(dataAGGautocorrlogwage**2)
	write(4,*) ' auto corr log wage',dataAGGautocorrlogwage,AGGautocorrlogwage
	ip = ip + 1
END IF


!construct objective function manually as well:
lf = sum((lfvec**2.0)*diagweight)/real(nmoments)
write(4,*) 'objective fun: ',lf

!get J statistic
IF(UseDiagWeight==1) THEN
	lJ = sum((lfvec**2.0)*diagweight)
	write(4,*) 'J statistic is ',lJ, ' with ',nmoments-nparam ,' df'
END IF

write(4,*) ' '

objeval = objeval+1
END SUBROUTINE MomentConditions