MODULE Parameters
IMPLICIT NONE
SAVE

integer,parameter :: long = 8

!DIRECTORIES
character(len=*), parameter	:: ParamOutputDir = "Output/"
character(len=*), parameter	:: ParamInputDir = "Input/"		   
character(len=*), parameter	:: ParamDataDir = "Data/"		   

!OPTIONS
integer,parameter  ::  Display              = 1
integer,parameter  ::  ReadParameters       = 1
integer,parameter  ::  SaveSimulations		= 0
integer,parameter  ::  DoGraphRegions		= 0
integer,parameter  ::  DoCalibration		= 1
integer,parameter  ::  UseDiagWeight		= 1
integer,parameter  ::  DoExperiments		= 1
integer,parameter  ::  DoTransition			= 0
integer,parameter  ::  DoChangeOnlyNewBorn	= 1
integer,parameter  ::  CalibrateFirstPeriod	= 0


integer,parameter  ::  Learning				= 1
integer,parameter  ::  TimeCost				= 1

integer,parameter  ::  ChooseKappa			= 1
integer,parameter  ::  ChooseTau0			= 1
integer,parameter  ::  ChooseTauE			= 1
integer,parameter  ::  ChooseTauV			= 0
integer,parameter  ::  ChooseTheta			= 0
integer,parameter  ::  ChooseVS0			= 1
integer,parameter  ::  ChooseVEta			= 1
integer,parameter  ::  ChooseRhoS			= 1
integer,parameter  ::  ChooseLambdaE		= 0
integer,parameter  ::  ChooseLambdaU1		= 0
integer,parameter  ::  ChooseLambdaU2		= 0
integer,parameter  ::  ChooseCostE			= 0
integer,parameter  ::  ChooseCostU1			= 0
integer,parameter  ::  ChooseCostU2			= 0
integer,parameter  ::  ChooseBen			= 1
integer,parameter  ::  ChooseU0				= 0
integer,parameter  ::  ChooseAlpha0			= 1
integer,parameter  ::  ChooseQuadWageProf	= 1
integer,parameter  ::  ChooseDelta			= 1
integer,parameter  ::  ChooseBias			= 0
integer,parameter  ::  ChooseTau0Bias		= 0

integer,parameter  ::  MatchAgeProfileMig			= 1
integer,parameter  ::  MatchAgeProfileUnemp			= 1	
integer,parameter  ::  MatchAgeProfileMeanLogWage	= 1
integer,parameter  ::  MatchAgeProfileVarLogWage	= 1
integer,parameter  ::  MatchLogWageMigNonDiff		= 1
integer,parameter  ::  MatchFracMatchedOccLoc		= 0
integer,parameter  ::  MatchOccSwitchRate			= 0	!NOT READY YET
integer,parameter  ::  MatchReturnMigRate			= 0
integer,parameter  ::  MatchAutoCorrLogWage			= 1

real(8),parameter  ::  RelativeWgtMigration			= 6.0
real(8),parameter  ::  RelativeWgtAgeMom			= 3.0
real(8),parameter  ::  RelativeWgtAutoCorrLogWage	= 2.0
real(8),parameter  ::  WeightValLogWageMigNonDiff	= -0.1	!sets the units for matching this, otherwise it puts too much effecive weight since number is close to 0


integer,parameter  ::  DoExperimentTheta		= 1
integer,parameter  ::  DoExperimentTau0			= 0
integer,parameter  ::  DoExperimentTau0Mult		= 1
integer,parameter  ::  DoExperimentBoth			= 1


! GRIDS
integer,parameter :: Nm = 5 !7			!Signal
integer,parameter :: Ns = 7 		!Skills
integer,parameter :: Nj = 2			!Locations
integer,parameter :: Nk = 2			!Occupations
integer,parameter :: Nz = 5			!Quadrature points for integration

!DEMOGRAPHIC PARAMETERS PARAMETERS
integer,parameter   :: Ttot = 40 	!number of periods to solve for (number of decision periods)


!SIMULATION PARAMETERS	
integer, parameter	:: nsim = 100000 !10000
integer, parameter	:: nsimtrans = nsim*Ttot
integer, parameter	:: Ttransition = 40

! PARAMETERS FOR THE REGION GRAPHS
integer, parameter :: gNs=200
integer, parameter :: gNm=200
integer, parameter :: gNgr=12 

END MODULE Parameters

