SUBROUTINE SaveOutput

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

IF(Display>=1) write(*,*) 'Saving output to disk'

CALL system ("mkdir -p " // trim(OutputDir))

! Parameters
OPEN(3, FILE = trim(OutputDir) // '/kappa.txt', STATUS = 'replace'); WRITE(3,*) kappa; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/beta.txt', STATUS = 'replace'); WRITE(3,*) bet; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/Tau0.txt', STATUS = 'replace'); WRITE(3,*) tau0; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/TauE.txt', STATUS = 'replace'); WRITE(3,*) tauE; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/TauV.txt', STATUS = 'replace'); WRITE(3,*) tauV; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/theta.txt', STATUS = 'replace'); WRITE(3,*) theta; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/VarS0.txt', STATUS = 'replace'); WRITE(3,*) vS0; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/VarEta.txt', STATUS = 'replace'); WRITE(3,*) Veta; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/rhoS.txt', STATUS = 'replace'); WRITE(3,*) rhos; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/Ttot.txt', STATUS = 'replace'); WRITE(3,*) Ttot; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/lambda_e.txt', STATUS = 'replace'); WRITE(3,*) lambda_e; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/lambda_u1.txt', STATUS = 'replace'); WRITE(3,*) lambda_u1; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/lambda_u2.txt', STATUS = 'replace'); WRITE(3,*) lambda_u2; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/c_e.txt', STATUS = 'replace'); WRITE(3,*) c_e; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/c_u1.txt', STATUS = 'replace'); WRITE(3,*) c_u1; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/c_u2.txt', STATUS = 'replace'); WRITE(3,*) c_u2; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/u_o.txt', STATUS = 'replace'); WRITE(3,*) u_0; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/ben.txt', STATUS = 'replace'); WRITE(3,*) ben; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // '/delta.txt', STATUS = 'replace'); WRITE(3,*) delta; CLOSE(3)

!Statistics
OPEN(3, FILE = trim(OutputDir) // '/Eisland_a.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Eisland_a)
OPEN(3, FILE = trim(OutputDir) // '/Eisland_b.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Eisland_b)
OPEN(3, FILE = trim(OutputDir) // '/Eloca.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Eloca)
OPEN(3, FILE = trim(OutputDir) // '/Eocca.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Eocca)
OPEN(3, FILE = trim(OutputDir) // '/Eoccb.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Eoccb)
OPEN(3, FILE = trim(OutputDir) // '/Eloca_occa.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Eloca_occa)
OPEN(3, FILE = trim(OutputDir) // '/Eloca_occb.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Eloca_occb)
OPEN(3, FILE = trim(OutputDir) // '/Elocb_occa.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Elocb_occa)
OPEN(3, FILE = trim(OutputDir) // '/Elocb_occb.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Elocb_occb)
OPEN(3, FILE = trim(OutputDir) // '/Emigab.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Emigab)
OPEN(3, FILE = trim(OutputDir) // '/Emigba.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Emigba)
OPEN(3, FILE = trim(OutputDir) // '/Emig.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Emig)
OPEN(3, FILE = trim(OutputDir) // '/Ematch_mig.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Ematch_mig)
OPEN(3, FILE = trim(OutputDir) // '/Eswitchab.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Eswitchab)
OPEN(3, FILE = trim(OutputDir) // '/Eswitchba.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Eswitchba)
OPEN(3, FILE = trim(OutputDir) // '/Eswitchau.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Eswitchau)
OPEN(3, FILE = trim(OutputDir) // '/Eswitchbu.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Eswitchbu)
OPEN(3, FILE = trim(OutputDir) // '/Eswitchua.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Eswitchua)
OPEN(3, FILE = trim(OutputDir) // '/Eswitchub.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Eswitchub)
OPEN(3, FILE = trim(OutputDir) // '/Eswitch.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Eswitch)
OPEN(3, FILE = trim(OutputDir) // '/Ewage_aa.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Ewage_aa)
OPEN(3, FILE = trim(OutputDir) // '/Ewage_ab.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Ewage_ab)
OPEN(3, FILE = trim(OutputDir) // '/Ewage_ba.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Ewage_ba)
OPEN(3, FILE = trim(OutputDir) // '/Ewage_bb.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Ewage_bb)
OPEN(3, FILE = trim(OutputDir) // '/Ewage_non.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Ewage_non)
OPEN(3, FILE = trim(OutputDir) // '/Ewage_mig.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Ewage_mig)
OPEN(3, FILE = trim(OutputDir) // '/Elogwage_non.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Elogwage_non)
OPEN(3, FILE = trim(OutputDir) // '/Elogwage_mig.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Elogwage_mig)
OPEN(3, FILE = trim(OutputDir) // '/Eretmig1.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-2,1,Eretmig1)
OPEN(3, FILE = trim(OutputDir) // '/Eretmig2.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-3,1,Eretmig2)
OPEN(3, FILE = trim(OutputDir) // '/Eretmig5.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-6,1,Eretmig5)
OPEN(3, FILE = trim(OutputDir) // '/Esearch_e.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Esearch_e)
OPEN(3, FILE = trim(OutputDir) // '/Esearch_u.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Esearch_u)
OPEN(3, FILE = trim(OutputDir) // '/Esearch_there.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Esearch_there)
OPEN(3, FILE = trim(OutputDir) // '/Esearch_here.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Esearch_here)
OPEN(3, FILE = trim(OutputDir) // '/Emig_u.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Emig_u)
OPEN(3, FILE = trim(OutputDir) // '/Emig_e.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Emig_e)
OPEN(3, FILE = trim(OutputDir) // '/Eu_mig.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Eu_mig)
!OPEN(3, FILE = trim(OutputDir) // '/Eoffer_mig.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Eoffer_mig)
!OPEN(3, FILE = trim(OutputDir) // '/Eoffer_mig_e.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Eoffer_mig_e)
OPEN(3, FILE = trim(OutputDir) // '/Eunemp.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Eunemp)
OPEN(3, FILE = trim(OutputDir) // '/Equit.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Equit)
OPEN(3, FILE = trim(OutputDir) // '/Elogwage.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Elogwage)
OPEN(3, FILE = trim(OutputDir) // '/Vlogwage.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Vlogwage)
OPEN(3, FILE = trim(OutputDir) // '/Emigq1.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Emigq1)
OPEN(3, FILE = trim(OutputDir) // '/Emigq2.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Emigq2)
OPEN(3, FILE = trim(OutputDir) // '/Emigq3.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Emigq3)
OPEN(3, FILE = trim(OutputDir) // '/Emigq4.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot,1,Emigq4)
OPEN(3, FILE = trim(OutputDir) // '/Emig1.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-1,1,Emig1)
OPEN(3, FILE = trim(OutputDir) // '/Emig2.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-2,1,Emig2)
OPEN(3, FILE = trim(OutputDir) // '/Emig5.txt', STATUS = 'replace'); CALL WriteMatrixLong(3,Ttot-5,1,Emig5)


OPEN(3, FILE = trim(OutputDir) // '/SummaryStats.txt', STATUS = 'replace')
	write(3,*) "Gross migration rate		", sum(Emig(1+(1-CalibrateFirstPeriod):Ttot-1))/real(Ttot-2+CalibrateFirstPeriod)
	write(3,*) "Fraction who ever migrate	", sum(evermigsim)/real(nsim)
	write(3,*) "Av number lifetime moves	", sum(nmovesim)/real(nsim)
	IF(count(nmovesim>0)>0) write(3,*) "Av number lifetime moves, positive", sum(nmovesim, mask = nmovesim>0)/real(count(nmovesim>0))
	IF(count(migsim(:,1:Ttot-2)>0)) write(3,*) "1yr return migration rate", REAL(COUNT(migsim(:,1:Ttot-2)==1 .and. (locsim(:,1:Ttot-2) == locsim(:,3:Ttot)))) / REAL(COUNT(migsim(:,1:Ttot-2)==1))
	IF(count(migsim(:,1:Ttot-2)>0)) write(3,*) "2yr return migration rate", REAL(COUNT(migsim(:,1:Ttot-3)==1 .and. (locsim(:,1:Ttot-3) == locsim(:,4:Ttot)))) / REAL(COUNT(migsim(:,1:Ttot-3)==1))
	IF(count(migsim(:,1:Ttot-2)>0)) write(3,*) "5yr return migration rate", REAL(COUNT(migsim(:,1:Ttot-6)==1 .and. (locsim(:,1:Ttot-6) == locsim(:,7:Ttot)))) / REAL(COUNT(migsim(:,1:Ttot-6)==1))
	write(3,*) "Mig-non wage difference, controling for age", sum((Ewage_mig(2:Ttot)-Ewage_non(2:Ttot))*Emig*(1-Emig)) / sum(Emig*(1-Emig))
	write(3,*) "Mig-non wage difference, not controling for age", sum( Ewage_mig(2:Ttot)-Ewage_non(2:Ttot)) / REAL(Ttot-1)
	write(3,*) "Mig-non log wage difference, controling for age", sum((Elogwage_mig(2:Ttot)-Elogwage_non(2:Ttot))*Emig*(1-Emig)) / sum(Emig*(1-Emig))
	write(3,*) "Mig-non log wage difference, not controling for age", sum( Elogwage_mig(2:Ttot)-Elogwage_non(2:Ttot)) / REAL(Ttot-1)
	write(3,*) "Mig-non employment difference, controling for age", sum((Eunemp_non(2:Ttot)-Eunemp_mig(2:Ttot))*Emig*(1-Emig)) / sum(Emig*(1-Emig))
	write(3,*) "Mig-non employment difference, not controling for age", sum( Eunemp_non(2:Ttot)-Eunemp_mig(2:Ttot)) / REAL(Ttot-1)
	write(3,*) "Overall unemployment rate" , sum(Eunemp)/REAL(Ttot)
	write(3,*) "Thiel Index" , AGGthiel
	write(3,*) "Fraction migrate for labor reasons, defn 1 " , AGGreason1labor
	write(3,*) "Fraction migrate for labor reasons, defn 2 " , AGGreason2labor
	write(3,*) "Auto correlation log wages " , AGGautocorrlogwage
CLOSE(3)


END SUBROUTINE SaveOutput