SUBROUTINE SetParameters

USE Parameters
USE Globals

IMPLICIT NONE

integer :: ip

bet 		= 0.96	!discount factor
kappaG		= 0.2	    !moving cost: money cost if TimeCost==0, time cost if TimeCost==1
tau0G		= 1.0	    !Prior precision !Note: these Taus are really Tau=1/var, not Tau^2=1/var as in notes.
tau0biasG	= 0.0 !0.5		!Additional precision of prior for initial location
tauEG		= 100.0	    !Shock precision
tauVG		= 1.0	    !Preference precision 
biasG		= 0.0 !2.0		!Additional bias on initial location, in terms of standad normal
thetaG		= 0.9	    !Relative prices (set to 0.999 instead of 1)
vS0G		= 0.2 		!Variance of skills at t=0
VetaG		= 0.1		!Variance of shocks to skills process
rhosG		= 0.95    	!Persistence of skills
lambda_eG	= 0.5
lambda_u1G	= 0.5
lambda_u2G	= 0.5
 c_eG		= 0.0
 c_u1G		= 0.0
 c_u2G		= 0.0
benG		= 0.2		!Unemployment income
u_0G		= 0.1		!Initial level of unemployment
alpha0G 	= 0.0
alpha1G 	= 0.05
alpha2G 	= -0.00035
deltaG      = 0.1

!READ IN PARAMETERS FROM TEXT FILE
IF (ReadParameters==1) THEN
	OPEN(1, FILE = trim(InputParamFile))
	READ(1,*) InputDir	
	READ(1,*) BaseOutputDir	
	READ(1,*) DataDir	
	READ(1,*) bet
	READ(1,*) kappaG
	READ(1,*) tau0G
	READ(1,*) tauEG
	READ(1,*) tauVG
	READ(1,*) thetaG
	READ(1,*) vS0G
	READ(1,*) VetaG
    READ(1,*) rhosG
    READ(1,*) lambda_eG
    READ(1,*) lambda_u1G
    READ(1,*) lambda_u2G
    READ(1,*) c_eG
    READ(1,*) c_u1G
    READ(1,*) c_u2G
    READ(1,*) benG
    READ(1,*) u_0G
	READ(1,*) alpha0G
	READ(1,*) alpha1G
	READ(1,*) alpha2G
	READ(1,*) deltaG
	READ(1,*) biasG
	READ(1,*) tau0biasG
    CLOSE(1)
ELSE
	InputDir = ParamInputDir
	BaseOutputDir = ParamOutputDir
	DataDir = ParamDataDir
END IF
OutputDir = BaseOutputDir
CALL system ("mkdir -p " // trim(OutputDir))

IF (DoCalibration==0) THEN
	kappa 	= kappaG
	tau0	= tau0G
	tauE	= tauEG
	tauV	= tauVG
	theta	= thetaG
	vS0		= vS0G
	Veta	= VetaG
	rhos	= rhosG
	lambda_e	= lambda_eG
	lambda_u1	= lambda_u1G
	lambda_u2	= lambda_u2G
	c_e		= c_eG
	c_u1	= c_u1G
	c_u2	= c_u2G
	ben		= benG
	u_0		= u_0G
	alpha0	= alpha0G
	alpha1	= alpha1G
	alpha2	= alpha2G
	delta   = deltaG
	bias	= biasG
	tau0bias  = tau0biasG
END IF

IF(DoGraphRegions==1) THEN
	OPEN(1, FILE = trim(InputDir) // 'graphN.txt'); READ(1,*) gNg; CLOSE(1)
	! s, m, t, n, island
	OPEN(1, FILE = trim(InputDir) // 'graphPoints.txt');
	DO ip=1,gNg
		READ(1,*) gPoints(:,ip)
	END DO
END IF


END SUBROUTINE SetParameters
