SUBROUTINE SimulateTransition

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

INTEGER                             :: ij,it,ioa, iob,iage,in
REAL(8)                             :: lEVa,lEVb,lAn1,lAn, lWe, lWu
INTEGER, DIMENSION(2)               :: loffer
INTEGER, DIMENSION(1)               :: lchoicej, lchoicek, lchoiceq
REAL(8), DIMENSION(0:1,0:1)         :: lJa, lJb
REAL(8), DIMENSION(0:1,0:1)         :: lL
REAL(8), DIMENSION(0:2)             :: lHu
REAL(8), DIMENSION(0:1)             :: lHe
REAL(8), DIMENSION(0:2)             :: lK

IF (Display>=1) write(*,*) 'Simulating transition'

!$OMP PARALLEL DO PRIVATE(it,ij)
DO in = 1,nsim
	DO it = 1,Ttot
		ij = (in-1)*Ttot + it

		idsim(ij) = in
		simtrans(0)%agesim(ij) = it

		simtrans(:)%Uasim(ij) = Uasim(in)
		simtrans(:)%Ubsim(ij) = Ubsim(in)

		IF (it<Ttot) THEN
			simtrans(0)%migsim(ij) = migsim(in,it)
			simtrans(0:1)%nasim(ij) = nasim(in,it:it+1)
			simtrans(0:1)%locsim(ij) = locsim(in,it:it+1)
			simtrans(0:1)%islandsim(ij) = islandsim(in,it:it+1)
			simtrans(0:1)%life(ij) = 0
		ELSE IF (it==Ttot) THEN
			simtrans(0)%migsim(ij) = 0
			simtrans(0)%nasim(ij) = nasim(in,Ttot)			
			simtrans(0)%locsim(ij) = locsim(in,Ttot)
			simtrans(0)%islandsim(ij) = islandsim(in,Ttot)
			simtrans(0)%life(ij) = 0
			simtrans(1)%nasim(ij) = nasim(in,1)			
			simtrans(1)%locsim(ij) = locsim(in,1)
			simtrans(1)%islandsim(ij) = islandsim(in,1)
		END IF
		simtrans(0)%Sasim(ij) = Sasim(in,it)
		simtrans(0)%Sbsim(ij) = Sbsim(in,it)
		simtrans(0)%belasim(ij) = belasim(in,it)
		simtrans(0)%belbsim(ij) = belbsim(in,it)
		simtrans(0)%occsim(ij) = occsim(in,it)
	END DO
END DO
!$OMP END PARALLEL DO


!$OMP PARALLEL DO PRIVATE(it,ioa,iob,lEVa,lEvb,lchoicej,lchoicek,lchoiceq,lk,lJa,lJb,lAn1,lAn,lWe,lWu,lL,lHu,lHe,loffer,iage)
DO ij=1,Nsimtrans
	DO it=1,Ttransition
	
 		IF(Display>=2 .and. (mod(ij,100000)==0) .and. it==1) write(*,*) 'Simulating transition indiviudal ',ij

		!update age
		IF(simtrans(it-1)%agesim(ij)<Ttot) simtrans(it)%agesim(ij) = simtrans(it-1)%agesim(ij) + 1
		IF(simtrans(it-1)%agesim(ij)==Ttot) simtrans(it)%agesim(ij) = 1
		iage = simtrans(it)%agesim(ij)
		
		!update life
		IF(iage==1) simtrans(it)%life(ij) = simtrans(it-1)%life(ij) + 1
		IF(iage>1)  simtrans(it)%life(ij) = simtrans(it-1)%life(ij)

		!update skills
		IF (iage==1) THEN
			CALL DiscreteDist1(simtrans(it)%Sasim(ij),Ns,Sdist(1,:),Srand(idsim(ij),iage,1))
			CALL DiscreteDist1(simtrans(it)%Sbsim(ij),Ns,Sdist(1,:),Srand(idsim(ij),iage,2))
		ELSE IF (iage>1) THEN
			CALL DiscreteDist1(simtrans(it)%Sasim(ij),Ns,Strans(iage-1,simtrans(it-1)%Sasim(ij),:),Srand(idsim(ij),iage,1))
			CALL DiscreteDist1(simtrans(it)%Sbsim(ij),Ns,Strans(iage-1,simtrans(it-1)%Sbsim(ij),:),Srand(idsim(ij),iage,2))
		END IF


		!update beliefs based on decisions

		IF (iage==1) THEN

			IF (simtrans(it)%locsim(ij)==1) THEN
				lAn1=(tau0+tauE*real(simtrans(it)%nasim(ij)-1))
				lAn=(tau0+tauE*real(simtrans(it)%nasim(ij)))
			
				simtrans(it)%belasim(ij) = lAn1*(simtrans(it)%Uasim(ij)+SQRT(1/Tau0)*M0rand(idsim(ij),1))/lAn + TauE*simtrans(it)%Uasim(ij)/lAn + SQRT(TauE)*Zrand(idsim(ij),simtrans(it)%nasim(ij),1)/lAn
				simtrans(it)%belbsim(ij) = 	simtrans(it)%Ubsim(ij)+SQRT(1/Tau0)*M0rand(idsim(ij),2)
			ELSE IF (simtrans(it)%locsim(ij)==2) THEN
				lAn1=(tau0+tauE*real(iage-simtrans(it)%nasim(ij)-1))
				lAn=(tau0+tauE*real(iage-simtrans(it)%nasim(ij)))

				simtrans(it)%belasim(ij) = simtrans(it)%Uasim(ij)+SQRT(1/Tau0)*M0rand(idsim(ij),1)
				simtrans(it)%belbsim(ij) = lAn1*(simtrans(it)%Ubsim(ij)+SQRT(1/Tau0)*M0rand(idsim(ij),2))/lAn + TauE*simtrans(it)%Ubsim(ij)/lAn + SQRT(TauE)*Zrand(idsim(ij),iage-simtrans(it)%nasim(ij),2)/lAn
			END IF
 	    
		ELSE IF(iage>1) THEN
		    IF (simtrans(it)%locsim(ij)==1) THEN
				IF(simtrans(it)%life(ij)==0 .and. ChangeOnlyNewBorn==1) THEN
					lAn1=(tau0_init+tauE*real(simtrans(it)%nasim(ij)-1))
					lAn=(tau0_init+tauE*real(simtrans(it)%nasim(ij)))
				ELSE IF(simtrans(it)%life(ij)>0 .or. ChangeOnlyNewBorn==0) THEN
					lAn1=(tau0+tauE*real(simtrans(it)%nasim(ij)-1))
					lAn=(tau0+tauE*real(simtrans(it)%nasim(ij)))
				END IF
				
				simtrans(it)%belasim(ij) = lAn1*simtrans(it-1)%belasim(ij)/lAn + TauE*simtrans(it)%Uasim(ij)/lAn + SQRT(TauE)*Zrand(idsim(ij),simtrans(it)%nasim(ij),1)/lAn
				simtrans(it)%belbsim(ij) = 	simtrans(it-1)%belbsim(ij)
			ELSE IF (simtrans(it)%locsim(ij)==2) THEN
				IF(simtrans(it)%life(ij)==0 .and. ChangeOnlyNewBorn==1) THEN
					lAn1=(tau0_init+tauE*real(iage-simtrans(it)%nasim(ij)-1))
					lAn=(tau0_init+tauE*real(iage-simtrans(it)%nasim(ij)))
				ELSE IF(simtrans(it)%life(ij)>0 .or. ChangeOnlyNewBorn==0) THEN
					lAn1=(tau0+tauE*real(iage-simtrans(it)%nasim(ij)-1))
					lAn=(tau0+tauE*real(iage-simtrans(it)%nasim(ij)))
				END IF
			
				simtrans(it)%belasim(ij) = simtrans(it-1)%belasim(ij)
				simtrans(it)%belbsim(ij) = lAn1*simtrans(it-1)%belbsim(ij)/lAn + TauE*simtrans(it)%Ubsim(ij)/lAn + SQRT(TauE)*Zrand(idsim(ij),iage-simtrans(it)%nasim(ij),2)/lAn
			END IF
		END IF
	
		!Now, work backwards to build all the elements needed for the occupation and search decisions
		lEVa=0.0
	    lEVb=0.0
		IF (iage<Ttot) THEN

		    DO ioa=0,1
	        DO iob=0,1
	            IF(TimeCost==0) THEN 
                    IF (simtrans(it)%locsim(ij)==1) THEN
					    lJa(ioa,iob) = 0.0
					    lJb(ioa,iob) = -kappa		    
                    ELSE IF (simtrans(it)%locsim(ij)==2) THEN
					    lJa(ioa,iob) = -kappa						   
					    lJb(ioa,iob) = 0.0
                    END IF
                ELSE IF(TimeCost==1) THEN 
                    IF (simtrans(it)%islandsim(ij)==0) THEN  !unemployment island. Costs are proportional to benefits
	                    IF (simtrans(it)%locsim(ij)==1) THEN
					        lJa(ioa,iob) = 0.0
					        lJb(ioa,iob) = -kappa * benG
                        ELSE IF (simtrans(it)%locsim(ij)==2) THEN
					        lJa(ioa,iob) = -kappa * benG
					        lJb(ioa,iob) = 0.0
                        END IF
                    ELSE IF (simtrans(it)%islandsim(ij)==1) THEN !employment island, costs are proportional to wage
                        IF (simtrans(it)%locsim(ij)==1) THEN
                            lJa(ioa,iob) = 0.0
					        lJb(ioa,iob) = -kappa * MAX(phi(iage)*theta*Sgrid(iage,simtrans(it)%Sasim(ij)),phi(iage)*Sgrid(iage,simtrans(it)%Sbsim(ij)))
                        ELSE IF (simtrans(it)%locsim(ij)==2) THEN
                            lJa(ioa,iob) = -kappa * MAX(phi(iage)*Sgrid(iage,simtrans(it)%Sasim(ij)),phi(iage)*theta*Sgrid(iage,simtrans(it)%Sbsim(ij)))
					        lJb(ioa,iob) = 0.0
                        END IF
                    END IF
                END IF

				IF(simtrans(it)%life(ij)==0 .and. ChangeOnlyNewBorn==1) THEN
	           		CALL BiLinInterp1 (Nm,Mgrid(simtrans(it)%nasim(ij),:,1),Nm, Mgrid(iage-simtrans(it)%nasim(ij),:,2),decINITIAL%EV(1+ioa,iage+1,simtrans(it)%nasim(ij)+1,simtrans(it)%Sasim(ij),simtrans(it)%Sbsim(ij),:,:),simtrans(it)%belasim(ij),simtrans(it)%belbsim(ij),lEVa)
	            	CALL BiLinInterp1 (Nm,Mgrid(simtrans(it)%nasim(ij),:,1),Nm, Mgrid(iage-simtrans(it)%nasim(ij),:,2),decINITIAL%EV(3+iob,iage+1,simtrans(it)%nasim(ij),simtrans(it)%Sasim(ij),simtrans(it)%Sbsim(ij),:,:),simtrans(it)%belasim(ij),simtrans(it)%belbsim(ij),lEVb)					
				ELSE IF(simtrans(it)%life(ij)>0 .or. ChangeOnlyNewBorn==0) THEN
	           		CALL BiLinInterp1 (Nm,Mgrid(simtrans(it)%nasim(ij),:,1),Nm, Mgrid(iage-simtrans(it)%nasim(ij),:,2),decFINAL%EV(1+ioa,iage+1,simtrans(it)%nasim(ij)+1,simtrans(it)%Sasim(ij),simtrans(it)%Sbsim(ij),:,:),simtrans(it)%belasim(ij),simtrans(it)%belbsim(ij),lEVa)
	            	CALL BiLinInterp1 (Nm,Mgrid(simtrans(it)%nasim(ij),:,1),Nm, Mgrid(iage-simtrans(it)%nasim(ij),:,2),decFINAL%EV(3+iob,iage+1,simtrans(it)%nasim(ij),simtrans(it)%Sasim(ij),simtrans(it)%Sbsim(ij),:,:),simtrans(it)%belasim(ij),simtrans(it)%belbsim(ij),lEVb)					
            	END IF
   				
	            lJa(ioa,iob)=lJa(ioa,iob)+ simtrans(it)%belasim(ij) +bet*lEVa 
                lJb(ioa,iob)=lJb(ioa,iob)+ simtrans(it)%belbsim(ij) +bet*lEVb	

                !Take the max over the relevant j's to get the L functions
                lL(ioa, iob)=MAXVAL((/lJa(ioa,iob),lJb(ioa,iob)/))
            END DO
	        END DO

	    END IF

		!Build H funcs, which are conditional on employment (and  of course location)        
        IF (simtrans(it)%locsim(ij)==1) THEN
            lHe(0)=lL(1,0)
            lHe(1)=lambda_e*lL(1,1)+(1.0d0-lambda_e)*lHe(0)-c_e
            lHu(0)=lL(0,0)
            lHu(1)=lambda_u1*lL(0,1)+(1.0d0-lambda_u1)*lHu(0)-c_u1
            lHu(2)=lambda_u2*lL(1,0)+(1.0d0-lambda_u2)*lHu(0)-c_u2
        ELSE 
            lHe(0)=lL(0,1)
            lHe(1)=lambda_e*lL(1,1)+(1.0d0-lambda_e)*lHe(0)-c_e
            lHu(0)=lL(0,0)
            lHu(1)=lambda_u1*lL(1,0)+(1.0d0-lambda_u1)*lHu(0)-c_u1
            lHu(2)=lambda_u2*lL(0,1)+(1.0d0-lambda_u2)*lHu(0)-c_u2 
        END IF               
            
        !take the max over q in the H functions to get W's (which are still conditional on employment/unemployment)
        lWe = MAXVAL(lHe)
        lWu = MAXVAL(lHu)

        ! Use them to build the K funcs 
        lK(0) = ben + lWu
        IF (simtrans(it)%locsim(ij)==1) THEN
            lK(1) = phi(iage)*Sgrid(iage,simtrans(it)%Sasim(ij)) + (1.0-delta)*lWe + delta*lWu
            lK(2) = phi(iage)*theta*Sgrid(iage,simtrans(it)%Sbsim(ij)) + (1.0-delta)*lWe + delta*lWu
        ELSE
            lK(1) = phi(iage)*theta*Sgrid(iage,simtrans(it)%Sasim(ij)) + (1.0-delta)*lWe + delta*lWu
            lK(2) = phi(iage)*Sgrid(iage,simtrans(it)%Sbsim(ij)) + (1.0-delta)*lWe + delta*lWu
        END IF
 
        ! Now the decisions
        ! Occupation: compare K-s, if in the production island, to choose occupation. Unemployed otherwise.
        IF (simtrans(it)%islandsim(ij)==0) THEN
            simtrans(it)%occsim(ij) = 0
        ELSE
            lchoicek = MAXLOC(lK)
            simtrans(it)%occsim(ij) = lchoicek(1)-1 !Because lK has indexes starting in 0 and this is not respected by maxloc
        END IF
        
        !wages
	    IF(simtrans(it)%locsim(ij)==1 .and. simtrans(it)%occsim(ij)==1) simtrans(it)%wsim(ij) = Sgrid(iage,simtrans(it)%Sasim(ij))*phi(iage)
	    IF(simtrans(it)%locsim(ij)==1 .and. simtrans(it)%occsim(ij)==2) simtrans(it)%wsim(ij) = theta*Sgrid(iage,simtrans(it)%Sbsim(ij))*phi(iage)
	    IF(simtrans(it)%locsim(ij)==2 .and. simtrans(it)%occsim(ij)==1) simtrans(it)%wsim(ij) = theta*Sgrid(iage,simtrans(it)%Sasim(ij))*phi(iage)
	    IF(simtrans(it)%locsim(ij)==2 .and. simtrans(it)%occsim(ij)==2) simtrans(it)%wsim(ij) = Sgrid(iage,simtrans(it)%Sbsim(ij))*phi(iage)
	    IF (simtrans(it)%locsim(ij)==0) simtrans(it)%wsim(ij) = 0.0
        
        !JOB DESTRUCTION SHOCK HERE        
        IF (simtrans(it)%occsim(ij)>0) THEN
            CALL DiscreteDist1(simtrans(it)%firedsim(ij),2,(/(1.0d0-delta), delta/),Drand(idsim(ij),iage))
            simtrans(it)%firedsim(ij) = simtrans(it)%firedsim(ij)-1            
        END IF

        ! Search : given occupation choice, decide about search.
        ! Search and migration decisions do not apply in the last period
		! searchsim = 1 for searching remotely, searchsim = 2 for searching here, searchsim = 0 for not search
        IF (iage<Ttot)THEN

            IF ((simtrans(it)%occsim(ij)==0) .or. (simtrans(it)%firedsim(ij)==1)) THEN
                lchoiceq=MAXLOC(lHu)
                simtrans(it)%searchsim(ij)=lchoiceq(1)-1 !Because lHu has indexes starting in 0 and this ir not respected by maxloc
            ELSE
                lchoiceq=MAXLOC(lHe)
                simtrans(it)%searchsim(ij)=lchoiceq(1)-1 !Because lHe has indexes starting in 0 and this ir not respected by maxloc
            END IF

            !Outcome of search
            loffer = 0	!whether offer in each of the locations

            IF ((simtrans(it)%occsim(ij)>0) .and. (simtrans(it)%firedsim(ij)==0)) THEN	!currently working
				loffer(simtrans(it)%locsim(ij)) = 1

                IF ((simtrans(it)%locsim(ij)==1) .and. (simtrans(it)%searchsim(ij)==1)) THEN
					CALL DiscreteDist1(loffer(2),2,(/(1.0d0-lambda_e), lambda_e/),Qrand(idsim(ij),iage))
					loffer(2) = loffer(2)-1 ! to make it [0,1] instead of [1,2] 
                ELSE IF ((simtrans(it)%locsim(ij)==2) .and. (simtrans(it)%searchsim(ij)==1)) THEN
					CALL DiscreteDist1(loffer(1),2,(/(1.0d0-lambda_e), lambda_e/),Qrand(idsim(ij),iage))
                    loffer(1)=loffer(1)-1 ! to make it [0,1] instead of [1,2] 
                END IF
                
            ELSE	!not currently working
                IF ((simtrans(it)%locsim(ij)==1) .and. (simtrans(it)%searchsim(ij)==1)) THEN
                    CALL DiscreteDist1(loffer(2),2,(/(1.0d0-lambda_u1), lambda_u1/),Qrand(idsim(ij),iage))
                    loffer(2)=loffer(2)-1 ! to make it [0,1] instead of [1,2] 
                ELSE IF ((simtrans(it)%locsim(ij)==2) .and. (simtrans(it)%searchsim(ij)==1)) THEN
                    CALL DiscreteDist1(loffer(1),2,(/(1.0d0-lambda_u1), lambda_u1/),Qrand(idsim(ij),iage))
                    loffer(1)=loffer(1)-1 ! to make it [0,1] instead of [1,2] 
                ELSE IF ((simtrans(it)%locsim(ij)==1) .and. (simtrans(it)%searchsim(ij)==2)) THEN
                    CALL DiscreteDist1(loffer(1),2,(/(1.0d0-lambda_u2), lambda_u2/),Qrand(idsim(ij),iage))
                    loffer(1)=loffer(1)-1 ! to make it [0,1] instead of [1,2] 
                ELSE IF ((simtrans(it)%locsim(ij)==2) .and. (simtrans(it)%searchsim(ij)==2)) THEN
                    CALL DiscreteDist1(loffer(2),2,(/(1.0d0-lambda_u2), lambda_u2/),Qrand(idsim(ij),iage))
                    loffer(2)=loffer(2)-1 ! to make it [0,1] instead of [1,2] 
                END IF
            END IF
            simtrans(it)%offersim(ij,1)=loffer(1)
            simtrans(it)%offersim(ij,2)=loffer(2)
        
            !Finally, location decision
            lchoicej			= MAXLOC( (/ lJa(loffer(1),loffer(2)),lJb(loffer(1),loffer(2)) /) )
            simtrans(it+1)%locsim(ij)	= lchoicej(1)
            simtrans(it+1)%islandsim(ij) 	= loffer(simtrans(it+1)%locsim(ij))

            ! update n
            IF (simtrans(it+1)%locsim(ij)==1) simtrans(it+1)%nasim(ij)=simtrans(it)%nasim(ij) + 1
            IF (simtrans(it+1)%locsim(ij)==2) simtrans(it+1)%nasim(ij)=simtrans(it)%nasim(ij)
            
            ! Migration decisions: ab means from a to b and vice versa.
            IF (simtrans(it+1)%locsim(ij) .ne. simtrans(it)%locsim(ij)) THEN

				simtrans(it)%migsim(ij) = 1
!                 evermigsim(ii) = 1               ! Record if ever migrated
!                 nmovesim(ii) = nmovesim(ii) + 1     ! Update number of moves
                
! 				IF (locsim(ii,it+1)==2) migabsim(ii,it) = 1
!                 IF (locsim(ii,it+1)==1) migbasim(ii,it) = 1
!                 IF (nmovesim(ii)>=1) repeatsim(ii,it)=1
				
! 				!reasons for moving: defn 1
! 				IF ((belasim(ii,it) > belbsim(ii,it) .and. locsim(ii,it+1) == 1) &
! 					.or. (belbsim(ii,it) > belasim(ii,it) .and. locsim(ii,it+1) == 2)) THEN
! 					reason1sim(ii,it) = 1	!amenity move
! 				ELSE
! 					reason1sim(ii,it) = 2	!labor move
! 				END IF
				
		    END IF
		
		ELSE IF (iage==Ttot) THEN
			
			!initial  island
			CALL DiscreteDist1(simtrans(it+1)%islandsim(ij),2,(/u_0,1.0_8-u_0/),island0rand(idsim(ij)))
		    simtrans(it+1)%islandsim(ij) = simtrans(it+1)%islandsim(ij)-1
		    		
			!initial location
			CALL DiscreteDist1(simtrans(it+1)%locsim(ij),2,(/0.5_8,0.5_8/),loc0rand(idsim(ij)))	
			IF(simtrans(it+1)%locsim(ij)==1) simtrans(it+1)%nasim(ij) = 1
			IF(simtrans(it+1)%locsim(ij)==2) simtrans(it+1)%nasim(ij) = 0

			simtrans(it)%migsim(ij) = 0

		END IF


    END DO
END DO
!$OMP END PARALLEL DO
! write(*,*) 'sum of migsim ', sum(migsim)
! write(*,*)'____________'
! write(*,*)sum(Sasim(:,:),dim=1)/real(nsim)
! write(*,*)'____________'
! write(*,*)sum(Sbsim(:,:),dim=1)/real(nsim)
! write(*,*)'____________'
! write(*,*) "skills of U not searching", SScheck/real(SScount)
! write(*,*) "skills of U  searching", SScheck2/real(SScount2)
! write(*,*) "skills of E", SScheck3/real(SScount3)
!write(*,*) "lowest point in skills grid", Sgrid(:,1)
!write(*,*) "second lowest point in skills grid", Sgrid(:,2)
!write(*,*) "third lowest point in skills grid", phi*Sgrid(:,3)
!write(*,*) "4th lowest point in skills grid", phi*Sgrid(:,4)
!write(*,*) "5th lowest point in skills grid", phi*Sgrid(:,5)
!write(*,*) "this numbers should be the same", SScount+Sscount2, count((occsim(:, 1:ttot-1)==0) .and. (searchsim<=1))


END SUBROUTINE SimulateTransition
