SUBROUTINE Simulations

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

INTEGER                             :: ii,it,in, ioa, iob, SScount, SScount2, SScount3
REAL(8)                             :: lEVa,lEVb,lAn1_a,lAn_a,lAn1_b,lAn_b, lWe, lWu , SScheck, SScheck2, SScheck3
INTEGER, DIMENSION(2)               :: loffer
INTEGER, DIMENSION(1)               :: lchoicej, lchoicek, lchoiceq
REAL(8), DIMENSION(0:1,0:1)         :: lJa, lJb
REAL(8), DIMENSION(0:1,0:1)         :: lL
REAL(8), DIMENSION(0:2)             :: lHu
REAL(8), DIMENSION(0:1)             :: lHe
REAL(8), DIMENSION(0:2)             :: lK

IF (Display>=1) write(*,*) 'Simulating model'

!initialize
migabsim	= 0
migbasim	= 0
switchabsim	= 0
switchbasim	= 0
switchausim	= 0
switchbusim	= 0
switchuasim	= 0
switchubsim	= 0
migsim		= 0
evermigsim	= 0
nmovesim	= 0
repeatsim	= 0
nasim 		= 0
searchsim	= 0
reason1sim	= 0
reason2sim	= 0

SScheck=0.0
SScount=0
SScheck2=0.0
SScount2=0
SScheck3=0.0
SScount3=0
!$OMP PARALLEL DO PRIVATE(it,in,ioa, iob, lEVa,lEvb,lchoicej, lchoicek, lchoiceq,lk,lJa, lJb, lAn1_a,lAn_a,lAn1_b,lAn_b, lWe, lWu, lL, lHu, lHe, loffer,SScount, SScount2, SScount3,SScheck, SScheck2, SScheck3)
DO ii=1,Nsim
 	IF(Display>=2 .and. (mod(ii,10000)==0)) write(*,*) 'Simulating indiviudal ',ii

	!initial  island
	CALL DiscreteDist1(islandsim(ii,1),2,(/u_0,1.0_8-u_0/),island0rand(ii))
    islandsim(ii,1)=islandsim(ii,1)-1

	!initial location
	CALL DiscreteDist1(locsim(ii,1),2,(/0.5_8,0.5_8/),loc0rand(ii))	

	!true utility and initial beliefs
	Uasim(ii)=SQRT(1/TauV)*(Urand(ii,1) + (2-locsim(ii,1))*bias)
	Ubsim(ii)=SQRT(1/TauV)*(Urand(ii,2) + (locsim(ii,1)-1)*bias)
	Masim(ii,0) = Uasim(ii)+SQRT(1/(Tau0+(2-locsim(ii,1))*tau0bias)) * M0rand(ii,1)
	Mbsim(ii,0) = Ubsim(ii)+SQRT(1/(Tau0+(locsim(ii,1)-1)*tau0bias)) * M0rand(ii,2)
	belasim(ii,0) = Masim(ii,0)    
	belbsim(ii,0) = Mbsim(ii,0)        
	IF(locsim(ii,1)==1) nasim(ii,1) = 1
	      
	!path for beliefs as function of n
	DO in = 1,Ttot
	    lAn1_a=(tau0+(2-locsim(ii,1))*tau0bias+tauE*real(in-1))
	    lAn_a=(tau0+(2-locsim(ii,1))*tau0bias+tauE*real(in))
	    Masim(ii,in) = lAn1_a*Masim(ii,in-1)/lAn_a + TauE*Uasim(ii)/lAn_a + SQRT(TauE)*Zrand(ii,in,1)/lAn_a

	    lAn1_b=(tau0+(locsim(ii,1)-1)*tau0bias+tauE*real(in-1))
	    lAn_b=(tau0+(locsim(ii,1)-1)*tau0bias+tauE*real(in))	
	    Mbsim(ii,in) = lAn1_b*Mbsim(ii,in-1)/lAn_b + TauE*Ubsim(ii)/lAn_b + SQRT(TauE)*Zrand(ii,in,2)/lAn_b
	END DO


	!ages 1 to Ttot
	DO it=1,Ttot

		!update skills
		IF (it==1) THEN
			CALL DiscreteDist1(Sasim(ii,it),Ns,Sdist(1,:),Srand(ii,it,1))
			CALL DiscreteDist1(Sbsim(ii,it),Ns,Sdist(1,:),Srand(ii,it,2))
        ELSE IF (it>1) THEN
			CALL DiscreteDist1(Sasim(ii,it),Ns,Strans(it-1,Sasim(ii,it-1),:),Srand(ii,it,1))
			CALL DiscreteDist1(Sbsim(ii,it),Ns,Strans(it-1,Sbsim(ii,it-1),:),Srand(ii,it,2))
		END IF
		
	
		!extract actual beliefs based on decisions
		belasim(ii,it) = Masim(ii,nasim(ii,it))
		belbsim(ii,it) = Mbsim(ii,it-nasim(ii,it))
		
		!Now, work backwards to build all the elements needed for the occupation and seacrh decisions
		lEVa=0.0
	    lEVb=0.0
		IF (it<Ttot) THEN

		    DO ioa=0,1
	        DO iob=0,1
	            IF(TimeCost==0) THEN 
                    IF (locsim(ii,it)==1) THEN
					    lJa(ioa,iob) = 0.0
					    lJb(ioa,iob) = -kappa		    
                    ELSE IF (locsim(ii,it)==2) THEN
					    lJa(ioa,iob) = -kappa						   
					    lJb(ioa,iob) = 0.0
                    END IF
                ELSEIF(TimeCost==1) THEN 
                    IF (islandsim(ii,it)==0) THEN  !unemployment island. Costs are proportional to benefits
	                    IF (locsim(ii,it)==1) THEN
					        lJa(ioa,iob) = 0.0
					        lJb(ioa,iob) = -kappa * benG
                        ELSE IF (locsim(ii,it)==2) THEN
					        lJa(ioa,iob) = -kappa * benG
					        lJb(ioa,iob) = 0.0
                        END IF
                    ELSEIF (islandsim(ii,it)==1) THEN !employment island, costs are proportional to wage
                        IF (locsim(ii,it)==1) THEN
                            lJa(ioa,iob) = 0.0
					        lJb(ioa,iob) = -kappa * MAX(phi(it)*theta*Sgrid(it,Sasim(ii,it)),phi(it)*Sgrid(it,Sbsim(ii,it)))
                        ELSE IF (locsim(ii,it)==2) THEN
                            lJa(ioa,iob) = -kappa * MAX(phi(it)*Sgrid(it,Sasim(ii,it)),phi(it)*theta*Sgrid(it,Sbsim(ii,it)))
					        lJb(ioa,iob) = 0.0
                        END IF
                    END IF
                END IF
        
	           	CALL BiLinInterp1 (Nm,Mgrid(nasim(ii,it),:,1),Nm, Mgrid(it-nasim(ii,it),:,2),EV(1+ioa,it+1,nasim(ii,it)+1,Sasim(ii,it),Sbsim(ii,it),:,:),Masim(ii,nasim(ii,it)),Mbsim(ii,it-nasim(ii,it)),lEVa)
	            CALL BiLinInterp1 (Nm,Mgrid(nasim(ii,it),:,1),Nm, Mgrid(it-nasim(ii,it),:,2),EV(3+iob,it+1,nasim(ii,it),Sasim(ii,it),Sbsim(ii,it),:,:),Masim(ii,nasim(ii,it)),Mbsim(ii,it-nasim(ii,it)),lEVb)					
   	            
   				
	            lJa(ioa,iob)=lJa(ioa,iob)+ Masim(ii,nasim(ii,it))    +bet*lEVa 
                lJb(ioa,iob)=lJb(ioa,iob)+ Mbsim(ii,it-nasim(ii,it)) +bet*lEVb	

                !Take the max over the relevant j's to get the L functions
                lL(ioa, iob)=MAXVAL((/lJa(ioa,iob),lJb(ioa,iob)/))
            END DO
	        END DO

	    ELSE
	        IF (locsim(ii,it)==1) lL = Masim(ii,nasim(ii,it))
	        IF (locsim(ii,it)==2) lL = Mbsim(ii,it-nasim(ii,it))
            !LL=0.0d0;
	    END IF
            !Build H funcs, which are conditional on employment (and  of course location)
            
        IF (locsim(ii,it)==1) THEN
            lHe(0)=lL(1,0)
            lHe(1)=lambda_e*lL(1,1)+(1.0d0-lambda_e)*lHe(0)-c_e
            lHu(0)=lL(0,0)
            lHu(1)=lambda_u1*lL(0,1)+(1.0d0-lambda_u1)*lHu(0)-c_u1
            lHu(2)=lambda_u2*lL(1,0)+(1.0d0-lambda_u2)*lHu(0)-c_u2
        ELSE 
            lHe(0)=lL(0,1)
            lHe(1)=lambda_e*lL(1,1)+(1.0d0-lambda_e)*lHe(0)-c_e
            lHu(0)=lL(0,0)
            lHu(1)=lambda_u1*lL(1,0)+(1.0d0-lambda_u1)*lHu(0)-c_u1
            lHu(2)=lambda_u2*lL(0,1)+(1.0d0-lambda_u2)*lHu(0)-c_u2 
        END IF               
            
        !take the max over q in the H functions to get W's (which are still conditional on employment/unemployment)
        lWe = MAXVAL(lHe)
        lWu = MAXVAL(lHu)

        ! Use them to build the K funcs 
        lK(0) = ben + lWu
        IF (locsim(ii,it)==1) THEN
            lK(1) = phi(it)*Sgrid(it,Sasim(ii,it)) + (1.0-delta)*lWe + delta*lWu
            lK(2) = phi(it)*theta*Sgrid(it,Sbsim(ii,it)) + (1.0-delta)*lWe + delta*lWu
        ELSE
            lK(1) = phi(it)*theta*Sgrid(it,Sasim(ii,it)) + (1.0-delta)*lWe + delta*lWu
            lK(2) = phi(it)*Sgrid(it,Sbsim(ii,it)) + (1.0-delta)*lWe + delta*lWu
        END IF
 
        ! Now the decisions
        ! Occupation: compare K-s, if in the production island, to choose occupation. Unemployed otherwise.
        IF (islandsim(ii,it)==0) THEN
            occsim(ii,it) = 0
        ELSE
            lchoicek = MAXLOC(lK)
            occsim(ii,it) = lchoicek(1)-1 !Because lK has indexes starting in 0 and this is not respected by maxloc
        END IF
        
        !wages
	    IF(locsim(ii,it)==1 .and. occsim(ii,it)==1) wsim(ii,it) = Sgrid(it,Sasim(ii,it))*phi(it)
	    IF(locsim(ii,it)==1 .and. occsim(ii,it)==2) wsim(ii,it) = theta*Sgrid(it,Sbsim(ii,it))*phi(it)
	    IF(locsim(ii,it)==2 .and. occsim(ii,it)==1) wsim(ii,it) = theta*Sgrid(it,Sasim(ii,it))*phi(it)
	    IF(locsim(ii,it)==2 .and. occsim(ii,it)==2) wsim(ii,it) = Sgrid(it,Sbsim(ii,it))*phi(it)
	    IF (occsim(ii,it)==0) wsim(ii,it) = 0.0
        
        
        !JOB DESTRUCTION SHOCK HERE
        
        IF (occsim(ii,it)>0) THEN
            CALL DiscreteDist1(firedsim(ii,it),2,(/(1.0d0-delta), delta/),Drand(ii,it))
            firedsim(ii,it) = firedsim(ii,it)-1
            
        END IF
        ! Search : given occupation choice, decide about search.
        ! Search and migration decisions do not apply in the last period
		! searchsim = 1 for searching remotely, searchsim = 2 for searching here, searchsim = 0 for not search
        IF (it<Ttot)THEN

            IF ((occsim(ii,it)==0) .or. (firedsim(ii,it)==1)) THEN
                lchoiceq=MAXLOC(lHu)
                searchsim(ii,it)=lchoiceq(1)-1 !Because lHu has indexes starting in 0 and this ir not respected by maxloc
                IF ((searchsim(ii,it)==0) .and. (locsim(ii,it)==1)) THEN
                    SScheck=SScheck+Sgrid(it,Sasim(ii,it))
                    SScount=SScount+1
                    ELSEIF ((searchsim(ii,it)==0) .and. (locsim(ii,it)==2)) THEN
                    SScheck=SScheck+Sgrid(it,Sbsim(ii,it))
                    SScount=SScount+1
                    ELSEIF ((searchsim(ii,it)==1) .and. (locsim(ii,it)==1)) THEN
                    SScheck2=SScheck2+Sgrid(it,Sasim(ii,it))
                    SScount2=SScount2+1
                    ELSEIF ((searchsim(ii,it)==1) .and. (locsim(ii,it)==2)) THEN
                    SScheck2=SScheck2+Sgrid(it,Sbsim(ii,it))
                    SScount2=SScount2+1
                    
                    END IF
            ELSE
                lchoiceq=MAXLOC(lHe)
                searchsim(ii,it)=lchoiceq(1)-1 !Because lHe has indexes starting in 0 and this ir not respected by maxloc
                IF (locsim(ii,it)==1) THEN
                    SScheck3=SScheck3+Sgrid(it,Sasim(ii,it))
                    Sscount3=SScount3+1
                    ELSEIF (locsim(ii,it)==2) THEN
                    SScheck3=SScheck3+Sgrid(it,Sbsim(ii,it))
                    Sscount3=SScount3+1
                END IF
            END IF

            !Outcome of search
            loffer = 0	!whether offer in each of the locations

            IF ((occsim(ii,it)>0) .and. (firedsim(ii,it)==0)) THEN	!currently working
				loffer(locsim(ii,it)) = 1

                IF ((locsim(ii,it)==1) .and. (searchsim(ii,it)==1)) THEN
					CALL DiscreteDist1(loffer(2),2,(/(1.0d0-lambda_e), lambda_e/),Qrand(ii,it))
					loffer(2) = loffer(2)-1 ! to make it [0,1] instead of [1,2] 
                ELSE IF ((locsim(ii,it)==2) .and. (searchsim(ii,it)==1)) THEN
					CALL DiscreteDist1(loffer(1),2,(/(1.0d0-lambda_e), lambda_e/),Qrand(ii,it))
                    loffer(1)=loffer(1)-1 ! to make it [0,1] instead of [1,2] 
                END IF
                
            ELSE	!not currently working
                IF ((locsim(ii,it)==1) .and. (searchsim(ii,it)==1)) THEN
                    CALL DiscreteDist1(loffer(2),2,(/(1.0d0-lambda_u1), lambda_u1/),Qrand(ii,it))
                    loffer(2)=loffer(2)-1 ! to make it [0,1] instead of [1,2] 
                ELSE IF ((locsim(ii,it)==2) .and. (searchsim(ii,it)==1)) THEN
                    CALL DiscreteDist1(loffer(1),2,(/(1.0d0-lambda_u1), lambda_u1/),Qrand(ii,it))
                    loffer(1)=loffer(1)-1 ! to make it [0,1] instead of [1,2] 
                ELSE IF ((locsim(ii,it)==1) .and. (searchsim(ii,it)==2)) THEN
                    CALL DiscreteDist1(loffer(1),2,(/(1.0d0-lambda_u2), lambda_u2/),Qrand(ii,it))
                    loffer(1)=loffer(1)-1 ! to make it [0,1] instead of [1,2] 
                ELSE IF ((locsim(ii,it)==2) .and. (searchsim(ii,it)==2)) THEN
                    CALL DiscreteDist1(loffer(2),2,(/(1.0d0-lambda_u2), lambda_u2/),Qrand(ii,it))
                    loffer(2)=loffer(2)-1 ! to make it [0,1] instead of [1,2] 
                END IF
            END IF
            offersim(ii,it,1)=loffer(1)
            offersim(ii,it,2)=loffer(2)
        
            !Finally, location decision
            lchoicej			= MAXLOC( (/ lJa(loffer(1),loffer(2)),lJb(loffer(1),loffer(2)) /) )
            locsim(ii,it+1)		= lchoicej(1)
            islandsim(ii,it+1) 	= loffer(locsim(ii,it+1))

            ! update n
            IF (locsim(ii,it+1)==1) nasim(ii,it+1)=nasim(ii,it) + 1
            IF (locsim(ii,it+1)==2) nasim(ii,it+1)=nasim(ii,it)
            
            ! Migration decisions: ab means from a to b and vice versa.
            IF (locsim(ii,it+1) .ne. locsim(ii,it)) THEN

				migsim(ii,it) = 1
                evermigsim(ii) = 1               ! Record if ever migrated
                nmovesim(ii) = nmovesim(ii) + 1     ! Update number of moves
                
				IF (locsim(ii,it+1)==2) migabsim(ii,it) = 1
                IF (locsim(ii,it+1)==1) migbasim(ii,it) = 1
                IF (nmovesim(ii)>=1) repeatsim(ii,it)=1
				
				!reasons for moving: defn 1
				IF ((belasim(ii,it) > belbsim(ii,it) .and. locsim(ii,it+1) == 1) &
					.or. (belbsim(ii,it) > belasim(ii,it) .and. locsim(ii,it+1) == 2)) THEN
					reason1sim(ii,it) = 1	!amenity move
				ELSE
					reason1sim(ii,it) = 2	!labor move
				END IF
				
		    END IF
		
		
		END IF

        IF (it>1) THEN

			!reasons for moving: defn 2 (requires next period wage so must do for last period)
            IF (migsim(ii,it-1)==1) THEN
				IF (wsim(ii,it) > wsim(ii,it-1)) THEN
					reason2sim(ii,it-1) = 2	!labor move
				ELSE IF ((wsim(ii,it-1)==0.0 .and. wsim(ii,it) == 0.0) .and. reason1sim(ii,it-1)==2) THEN
					reason2sim(ii,it-1) = 2	!labor move
				ELSE
					reason2sim(ii,it-1) = 1	!amenity move
				END IF
			END IF

			!job switches and transitions from unemployment to employment (these are saved as in t-1, but start in t=2)
            IF (occsim(ii,it) .ne. occsim(ii,it-1)) THEN            
				IF ((occsim(ii,it)==2) .and. (occsim(ii,it-1)==1))  switchabsim(ii,it-1) = 1
				IF ((occsim(ii,it)==2) .and. (occsim(ii,it-1)==0))  switchubsim(ii,it-1) = 1
				IF ((occsim(ii,it)==1) .and. (occsim(ii,it-1)==2))  switchbasim(ii,it-1) = 1
				IF ((occsim(ii,it)==1) .and. (occsim(ii,it-1)==0))  switchuasim(ii,it-1) = 1
				IF ((occsim(ii,it)==0) .and. (occsim(ii,it-1)==1))  switchausim(ii,it-1) = 1
				IF ((occsim(ii,it)==0) .and. (occsim(ii,it-1)==2))  switchbusim(ii,it-1) = 1
            END IF

        END IF

    END DO
END DO
!$OMP END PARALLEL DO
! write(*,*) 'sum of migsim ', sum(migsim)
! write(*,*)'____________'
! write(*,*)sum(Sasim(:,:),dim=1)/real(nsim)
! write(*,*)'____________'
! write(*,*)sum(Sbsim(:,:),dim=1)/real(nsim)
! write(*,*)'____________'
! write(*,*) "skills of U not searching", SScheck/real(SScount)
! write(*,*) "skills of U  searching", SScheck2/real(SScount2)
! write(*,*) "skills of E", SScheck3/real(SScount3)
!write(*,*) "lowest point in skills grid", Sgrid(:,1)
!write(*,*) "second lowest point in skills grid", Sgrid(:,2)
!write(*,*) "third lowest point in skills grid", phi*Sgrid(:,3)
!write(*,*) "4th lowest point in skills grid", phi*Sgrid(:,4)
!write(*,*) "5th lowest point in skills grid", phi*Sgrid(:,5)
!write(*,*) "this numbers should be the same", SScount+Sscount2, count((occsim(:, 1:ttot-1)==0) .and. (searchsim<=1))


END SUBROUTINE Simulations
