SUBROUTINE Transition

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

INTEGER		:: it,in,ij

! initial SS decision rules
IF(Display>=1) write(*,*) 'SOLVING INITIAL SS'
CALL Grids
CALL Decisions
CALL Simulations

decINITIAL%EV = EV
decINITIAL%V = V


!solve for final SS decision rules
IF(Display>=1) write(*,*) 'SOLVING FINAL SS'

theta_init = theta
tau0_init = tau0

theta = 0.91
tau0 = tau0 + 0.5*tauE

CALL Grids
CALL Decisions

decFINAL%EV = EV
decFINAL%V = V

ChangeOnlyNewBorn=0
OutputDir = trim(BaseOutputDir) // '/trans_instant/'
CALL SimulateTransition
CALL TransitionStats
CALL TransitionOutput

IF(DoChangeOnlyNewBorn==1) THEN
	ChangeOnlyNewBorn=1
	OutputDir = trim(BaseOutputDir) // '/trans_newborn/'
	CALL SimulateTransition
	CALL TransitionStats
	CALL TransitionOutput
END IF


END SUBROUTINE Transition