SUBROUTINE TransitionStats

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

INTEGER		:: it
REAL(8)		:: lminage,lmaxage
! INTEGER		:: lcount,lq1
! REAL(8)		:: lw1,lw2,lw3,lw22,lw32,lw2w3
! REAL(8)		:: lpa,lpb,lpAa,lpAb,lpBa,lpBb,lentropy,lentropyA,lentropyB

IF (Display>=1) write(*,*) 'Calculating stats'

lminage = 2
lmaxage = 2+nage-1

DO it = 0,Ttransition
	pathEage(it) = REAL(SUM(simtrans(it)%agesim, DIM=1)) / REAL(nsimtrans)
	pathEloca(it) = SUM(2.0-simtrans(it)%locsim, DIM=1) / REAL(nsimtrans)
	pathEocca(it) = REAL(COUNT((simtrans(it)%occsim==1), DIM=1)) / REAL(nsimtrans)
	pathEoccb(it) = REAL(COUNT((simtrans(it)%occsim==2), DIM=1)) / REAL(nsimtrans)
	pathEisland_a(it)   = REAL(COUNT((simtrans(it)%islandsim==1 .and. simtrans(it)%locsim==1), DIM=1)) / REAL(nsimtrans)
	pathEisland_b(it)   = REAL(COUNT((simtrans(it)%islandsim==1 .and. simtrans(it)%locsim==2), DIM=1)) / REAL(nsimtrans)
	pathEloca_occa(it) 	= REAL(COUNT((simtrans(it)%locsim==1 .and. simtrans(it)%occsim==1), DIM=1)) / REAL(nsimtrans)
	pathEloca_occb(it) 	= REAL(COUNT((simtrans(it)%locsim==1 .and. simtrans(it)%occsim==2), DIM=1)) / REAL(nsimtrans)
	pathElocb_occa(it) 	= REAL(COUNT((simtrans(it)%locsim==2 .and. simtrans(it)%occsim==1), DIM=1)) / REAL(nsimtrans)
	pathElocb_occb(it) 	= REAL(COUNT((simtrans(it)%locsim==2 .and. simtrans(it)%occsim==2), DIM=1)) / REAL(nsimtrans)
	pathEmig(it) 		= REAL(SUM(simtrans(it)%migsim, DIM=1, MASK=(simtrans(it)%agesim>=lminage .and. simtrans(it)%agesim<=lmaxage) )) / REAL(COUNT(simtrans(it)%agesim>=lminage .and. simtrans(it)%agesim<=lmaxage) )


! Eswitchab 	= REAL(SUM(switchabsim, DIM=1)) / REAL(nsim)
! Eswitchba 	= REAL(SUM(switchbasim, DIM=1)) / REAL(nsim)
! Eswitchau 	= REAL(SUM(switchausim, DIM=1)) / REAL(nsim)
! Eswitchbu 	= REAL(SUM(switchbusim, DIM=1)) / REAL(nsim)
! Eswitchua 	= REAL(SUM(switchuasim, DIM=1)) / REAL(nsim)
! Eswitchub 	= REAL(SUM(switchubsim, DIM=1)) / REAL(nsim)
! Eswitch 	= REAL(COUNT((switchabsim==1 .or. switchbasim==1), DIM=1)) / REAL(nsim)
	pathEunemp(it)		= REAL(COUNT(((simtrans(it)%occsim==0) .or. (simtrans(it)%firedsim==1)), DIM=1))/REAL(nsimtrans)

! Esearch_e	= REAL(COUNT((searchsim>0) .and. ((occsim(:,1:Ttot-1)>0) .and. (firedsim(:,1:Ttot-1)==0) ), DIM=1))/REAL(Nsim)
! Esearch_u	= REAL(COUNT((searchsim>0) .and. ((occsim(:,1:Ttot-1)==0) .or. (firedsim(:,1:Ttot-1)==1) ), DIM=1))/REAL(Nsim)
! Esearch_here= REAL(COUNT((searchsim==2) , DIM=1))/REAL(Nsim)	
! Esearch_there= REAL(COUNT((searchsim==1) , DIM=1))/REAL(Nsim)		
! 
! Ewage_aa = 0.0
! Ewage_ab = 0.0
! Ewage_ba = 0.0
! Ewage_bb = 0.0
! Elogwage = 0.0
! Elogwage2 = 0.0
! Vlogwage = 0.0
! DO it = 1,Ttot
! 	IF(COUNT((locsim(:,it)==1 .and. occsim(:,it)==1))>0)	Ewage_aa(it)	= SUM(wsim(:,it), MASK=(locsim(:,it)==1 .and. occsim(:,it)==1)) / REAL(COUNT((locsim(:,it)==1 .and. occsim(:,it)==1)))
! 	IF(COUNT((locsim(:,it)==1 .and. occsim(:,it)==2))>0)	Ewage_ab(it)	= SUM(wsim(:,it), MASK=(locsim(:,it)==1 .and. occsim(:,it)==2)) / REAL(COUNT((locsim(:,it)==1 .and. occsim(:,it)==2)))
! 	IF(COUNT((locsim(:,it)==2 .and. occsim(:,it)==1))>0)	Ewage_ba(it)	= SUM(wsim(:,it), MASK=(locsim(:,it)==2 .and. occsim(:,it)==1)) / REAL(COUNT((locsim(:,it)==2 .and. occsim(:,it)==1)))
! 	IF(COUNT((locsim(:,it)==2 .and. occsim(:,it)==2))>0)	Ewage_bb(it)	= SUM(wsim(:,it), MASK=(locsim(:,it)==2 .and. occsim(:,it)==2)) / REAL(COUNT((locsim(:,it)==2 .and. occsim(:,it)==2)))
! 	IF(COUNT(occsim(:,it)>0)>0)	Elogwage(it) = SUM(log(wsim(:,it)), MASK=(occsim(:,it)>0)) / REAL(COUNT(occsim(:,it)>0))
! 	IF(COUNT(occsim(:,it)>0)>0) Elogwage2(it) = SUM(log(wsim(:,it))**2, MASK=(occsim(:,it)>0)) / REAL(COUNT(occsim(:,it)>0))
! 	IF(COUNT(occsim(:,it)>0)>0) Vlogwage(it) = Elogwage2(it)-Elogwage(it)**2
! 	IF(COUNT(islandsim(:,it)==1)>0) Equit(it)	= REAL(COUNT((occsim(:,it)==0) .and. (islandsim(:,it)==1)))/REAL(COUNT((islandsim(:,it)==1)))
! END DO	
END DO


! Ewage_mig = 0.0
! Ewage_non = 0.0
! Elogwage_mig = 0.0
! Elogwage_non = 0.0
! Eunemp_mig = 0.0
! Eunemp_non = 0.0
! DO it = 2,Ttot
! 	IF(COUNT((migsim(:,it-1)==1) .and. (occsim(:,it)>0))>0) Ewage_mig(it)	= SUM(wsim(:,it), MASK=((migsim(:,it-1)==1) .and. (occsim(:,it)>0))) / REAL(COUNT((migsim(:,it-1)==1) .and. (occsim(:,it)>0)))
! 	IF(COUNT((migsim(:,it-1)==0) .and. (occsim(:,it)>0))>0) Ewage_non(it)	= SUM(wsim(:,it), MASK=((migsim(:,it-1)==0) .and. (occsim(:,it)>0))) / REAL(COUNT((migsim(:,it-1)==0) .and. (occsim(:,it)>0)))
! 	IF(COUNT((migsim(:,it-1)==1) .and. (occsim(:,it)>0))>0) Elogwage_mig(it)	= SUM(log(wsim(:,it)), MASK=((migsim(:,it-1)==1) .and. (occsim(:,it)>0))) / REAL(COUNT((migsim(:,it-1)==1) .and. (occsim(:,it)>0)))
! 	IF(COUNT((migsim(:,it-1)==0) .and. (occsim(:,it)>0))>0) Elogwage_non(it)	= SUM(log(wsim(:,it)), MASK=((migsim(:,it-1)==0) .and. (occsim(:,it)>0))) / REAL(COUNT((migsim(:,it-1)==0) .and. (occsim(:,it)>0)))
!     IF(COUNT(migsim(:,it-1)==1)>0) Eunemp_mig(it)	= REAL(COUNT(((occsim(:,it)==0) .or. (firedsim(:,it)==1)) .and. (migsim(:,it-1)==1))) / REAL(COUNT(migsim(:,it-1)==1))
!     IF(COUNT(migsim(:,it-1)==0)>0) Eunemp_non(it)	= REAL(COUNT(((occsim(:,it)==0) .or. (firedsim(:,it)==1)) .and. (migsim(:,it-1)==0))) / REAL(COUNT(migsim(:,it-1)==0))
! END DO
! 
! DO it = 1,Ttot-2
! 	IF(COUNT(migsim(:,it)==1)>0) Eretmig1(it) = REAL(COUNT(migsim(:,it)==1 .and. (locsim(:,it) == locsim(:,it+2)))) / REAL(COUNT(migsim(:,it)==1))
! END DO
! DO it = 1,Ttot-3
! 	IF(COUNT(migsim(:,it)==1)>0) Eretmig2(it) = REAL(COUNT(migsim(:,it)==1 .and. (locsim(:,it) == locsim(:,it+3)))) / REAL(COUNT(migsim(:,it)==1))
! END DO
! DO it = 1,Ttot-6
! 	IF(COUNT(migsim(:,it)==1)>0) Eretmig5(it) = REAL(COUNT(migsim(:,it)==1 .and. (locsim(:,it) == locsim(:,it+6)))) / REAL(COUNT(migsim(:,it)==1))
! END DO
! 
! 
! Eu_mig = 0.0
! Emig_e = 0.0
! Emig_u = 0.0
! DO it = 1,Ttot-1
! 	! fraction of migrants who are unemployed (after arrivinb)
! 	IF(COUNT((migsim(:,it)==1), DIM=1)>0) Eu_mig(it) = REAL(COUNT((occsim(:,it+1)==0) .and. (migsim(:,it)==1), DIM=1))/REAL(COUNT((migsim(:,it)==1)))
! 	!Migration rate for U/E
! 	IF(COUNT(occsim(:,it+1)>0)>0)	Emig_e(it)	= REAL(COUNT((occsim(:,it+1)>0) .and. (migsim(:,it)==1)))/REAL(COUNT(occsim(:,it+1)>0))
! 	IF(COUNT(occsim(:,it+1)==0)>0)	Emig_u(it)	= REAL(COUNT((occsim(:,it+1)==0) .and. (migsim(:,it)==1)))/REAL(COUNT((occsim(:,it+1)==0)))
! END DO



END SUBROUTINE TransitionStats