%% Parameters
clear all;
close all;

BaseOutputDir =  '~/replication_materials/model_final/Output14Aug2015HS/';
DataDir = '~/replication_materials/model_final/Data/HS/';
PlotDir = '';
Name = 'output';

FirstFig = 10;
Save = 0;
CalibrateFirstPeriod = 0;
Educ = 'H'; %'H' for high school, 'C' for college
PlotsForPaper = 1;
Transition = 0;

if Educ=='H'
    Age1 = 19;
elseif Educ=='C'
    Age1 = 23;
end
ist = 2;
if CalibrateFirstPeriod==1
    Age1 = Age1-1;
    ist = 1;
end    
    


%% Configurations

config{1} = '';
config{2} = 'ExpTheta';
config{3} = 'ExpTau0_1';
config{4} = 'ExpTau0_075';
config{5} = 'ExpTau0_05';
config{6} = 'ExpTau0_025';
config{7} = 'ExpTau0_008';
config{8} = 'ExpBoth_05';
config{9} = 'ExpBoth_025';
config{10} = 'ExpBoth_008';

nconfig = size(config);
index = [1];

%% Load Data
Ttot = importdata([BaseOutputDir config{1} '/Ttot.txt']);
vecage = Age1-1+[1:Ttot]';
vecage1 = Age1-1+[1:Ttot-1]';
vecage2 = Age1-1+[1:Ttot-2]';
vecage3 = Age1-1+[1:Ttot-3]';
vecage6 = Age1-1+[1:Ttot-6]';


for in = 1:nconfig(2)

    Eloca{in} = importdata([BaseOutputDir config{in} '/Eloca.txt']);
    Eocca{in} = importdata([BaseOutputDir config{in} '/Eocca.txt']);
    Eoccb{in} = importdata([BaseOutputDir config{in} '/Eoccb.txt']);
    Eloca_occa{in} = importdata([BaseOutputDir config{in} '/Eloca_occa.txt']);
    Eloca_occb{in} = importdata([BaseOutputDir config{in} '/Eloca_occb.txt']);
    Elocb_occa{in} = importdata([BaseOutputDir config{in} '/Elocb_occa.txt']);
    Elocb_occb{in} = importdata([BaseOutputDir config{in} '/Elocb_occb.txt']);
    Emigab{in} = importdata([BaseOutputDir config{in} '/Emigab.txt']);
    Emigba{in} = importdata([BaseOutputDir config{in} '/Emigba.txt']);
    Emig{in} = importdata([BaseOutputDir config{in} '/Emig.txt']);
    Emig1{in} = importdata([BaseOutputDir config{in} '/Emig1.txt']);
    Emig2{in} = importdata([BaseOutputDir config{in} '/Emig2.txt']);
    Emig5{in} = importdata([BaseOutputDir config{in} '/Emig5.txt']);
    Eswitchab{in} = importdata([BaseOutputDir config{in} '/Eswitchab.txt']);
    Eswitchba{in} = importdata([BaseOutputDir config{in} '/Eswitchba.txt']);
    Eswitchau{in} = importdata([BaseOutputDir config{in} '/Eswitchau.txt']);
    Eswitchbu{in} = importdata([BaseOutputDir config{in} '/Eswitchbu.txt']);
    Eswitchua{in} = importdata([BaseOutputDir config{in} '/Eswitchua.txt']);
    Eswitchub{in} = importdata([BaseOutputDir config{in} '/Eswitchub.txt']);
    Eswitch{in} = importdata([BaseOutputDir config{in} '/Eswitch.txt']);
    Ewage_aa{in} = importdata([BaseOutputDir config{in} '/Ewage_aa.txt']);
    Ewage_ab{in} = importdata([BaseOutputDir config{in} '/Ewage_ab.txt']);
    Ewage_ba{in} = importdata([BaseOutputDir config{in} '/Ewage_ba.txt']);
    Ewage_bb{in} = importdata([BaseOutputDir config{in} '/Ewage_bb.txt']);
    Ewage_non{in} = importdata([BaseOutputDir config{in} '/Ewage_non.txt']);
    Ewage_mig{in} = importdata([BaseOutputDir config{in} '/Ewage_mig.txt']);    
    Elogwage_non{in} = importdata([BaseOutputDir config{in} '/Elogwage_non.txt']);
    Elogwage_mig{in} = importdata([BaseOutputDir config{in} '/Elogwage_mig.txt']);    
    Eretmig1{in} = importdata([BaseOutputDir config{in} '/Eretmig1.txt']);    
    Eretmig2{in} = importdata([BaseOutputDir config{in} '/Eretmig2.txt']);    
    Eretmig5{in} = importdata([BaseOutputDir config{in} '/Eretmig5.txt']);    
    
    Elogwage{in} = importdata([BaseOutputDir config{in} '/Elogwage.txt']);
    Vlogwage{in} = importdata([BaseOutputDir config{in} '/Vlogwage.txt']);
    Emigq1{in} = importdata([BaseOutputDir config{in} '/Emigq1.txt']);
    Emigq2{in} = importdata([BaseOutputDir config{in} '/Emigq2.txt']);
    Emigq3{in} = importdata([BaseOutputDir config{in} '/Emigq3.txt']);
    Emigq4{in} = importdata([BaseOutputDir config{in} '/Emigq4.txt']);
    
    Ewage_match{in} = (Ewage_aa{in}.*Eloca_occa{in} + Ewage_bb{in}.*Elocb_occb{in})...
                        ./(Eloca_occa{in}+Elocb_occb{in});
    Ewage_unmatch{in} = (Ewage_ab{in}.*Eloca_occb{in} + Ewage_ba{in}.*Elocb_occa{in})...
                        ./(Eloca_occb{in}+Elocb_occa{in});
    Ewage_non{in}(1) = NaN; Elogwage_non{in}(1) = NaN;
    Ewage_mig{in}(1) = NaN; Elogwage_mig{in}(1) = NaN;
   
    Eunemp{in}  = importdata([BaseOutputDir config{in} '/Eunemp.txt']);    
    Equit{in}  = importdata([BaseOutputDir config{in} '/Equit.txt']);    
    Esearch_e{in}  = importdata([BaseOutputDir config{in} '/Esearch_e.txt']);    
    Esearch_u{in}  = importdata([BaseOutputDir config{in} '/Esearch_u.txt']);    
    Esearch_here{in}  = importdata([BaseOutputDir config{in} '/Esearch_here.txt']);    
    Esearch_there{in}  = importdata([BaseOutputDir config{in} '/Esearch_there.txt']);    

    Emig_u{in}  = importdata([BaseOutputDir config{in} '/Emig_u.txt']); 
    Emig_e{in}  = importdata([BaseOutputDir config{in} '/Emig_e.txt']); 
    Eu_mig{in}  = importdata([BaseOutputDir config{in} '/Eu_mig.txt']); 
    %Eoffer_mig{in}  = importdata([BaseOutputDir config{in} '/Eoffer_mig.txt']);    
    %Eoffer_mig_e{in}  = importdata([BaseOutputDir config{in} '/Eoffer_mig_e.txt']);    
end

% pathEmig=importdata([BaseOutputDir '/trans_instant/pathEmig.txt']);

%load data;
nage            = importdata([DataDir 'nage.txt']);
dataEmig        = importdata([DataDir 'dataEmig.txt']);
dataEmigEND     = importdata([DataDir 'dataEmigEND.txt']);
dataElogwage    = importdata([DataDir 'dataElogwage.txt']);
dataVlogwage    = importdata([DataDir 'dataVlogwage.txt']);
dataEunemp      = importdata([DataDir 'dataEunemp.txt']);


%% Linestyles

ls{1} = 'r-';
ls{2} = 'c-.';
ls{3} = 'm:';
ls{4} = 'g-.';
ls{5} = 'b--';
ls{6} = 'c-';
ls{7} = 'y-';

f= FirstFig;


%% Plots for paper
if PlotsForPaper==1
    figure;
    plot([Age1:nage+Age1-1]',dataElogwage,'k--',[Age1:nage+Age1-1]',Elogwage{1}(ist+1:ist+1+nage-1),'r-','Linewidth',3.5);
    ylim([0.8 2.0]);
    grid on;
    xlim([18 55]);
    xlabel('Age','FontSize',16);
    legend('Mean log wage: data','Mean log wage: model','Location','South');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_fit_meanwage']);
    end
    
    figure;
    plot([Age1:nage+Age1-1]',dataVlogwage,'k--',[Age1:nage+Age1-1]',Vlogwage{1}(ist+1:ist+1+nage-1),'r-','Linewidth',3.5);
    ylim([0 0.7]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Variance of log wage: data','Variance of log wage: model','Location','North');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_fit_varwage']);
    end

    figure;
    plot([Age1:nage+Age1-1]',1-dataEunemp,'k--',[Age1:nage+Age1-1]',1-Eunemp{1}(ist+1:ist+1+nage-1),'r-','Linewidth',3.5);
    ylim([0.4 0.9]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Employment rate: data','Mean log wage: model','Location','South');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_fit_emp']);
    end
%%
    figure;    
    plot([Age1:nage+Age1-1]',dataEmig,'k--',[Age1:nage+Age1-1]',Emig{1}(ist:ist+nage-1),'r-','Linewidth',3.5);
%     ylim([0 0.15]);
     ylim([0 0.16]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Migration rate: data','Migration rate: model','Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_fit_migration']);
    end
%%
    figure;    
    plot([Age1:nage+Age1-1]',Emig{1}(ist:ist+nage-1),'r-','Linewidth',3.5);
    hold on; 
    for i= 2:2
        plot([Age1:nage+Age1-1]',Emig{i}(ist:ist+nage-1),ls{i},'Linewidth',2.5);
    end
    plot([Age1:nage+Age1-1]',Emig{8}(ist:ist+nage-1),ls{3},'Linewidth',3.5);
    hold off;

    ylim([0 0.16]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Migration rate: baseline model','Migration rate: less geographic specificity',...
        'Migration rate: more information','Migration rate: both changes','Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_experiment_migration']);
    end

%%
    figure;    
    plot([Age1:nage+Age1-1]',Emig{1}(ist:ist+nage-1),'r-','Linewidth',3.5);
    hold on; 
    for i= 2:2
        plot([Age1:nage+Age1-1]',Emig{i}(ist:ist+nage-1),'b--','Linewidth',3.5);
    end
    hold off;

    ylim([0 0.16]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Migration rate: baseline model','Migration rate: less geographic specificity',...
        'Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_experiment_migration_skills']);
    end

    
    %%
    figure;    
    plot([Age1:nage+Age1-5]',Emig5{1}(ist:ist+nage-5),'r-','Linewidth',3.5);
    hold on; 
    for i= 2:2
        plot([Age1:nage+Age1-5]',Emig5{i}(ist:ist+nage-5),'b--','Linewidth',3.5);
    end
    hold off;

    ylim([0 0.4]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Migration rate (5yr): baseline model','Migration rate (5yr): less geographic specificity',...
        'Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_experiment_migration5_skills']);
    end
    
    %%
    figure;    
    plot([Age1:nage+Age1-2]',Eretmig1{1}(ist:ist+nage-2),'r-','Linewidth',3.5);
    hold on; 
    for i= 2:2
        plot([Age1:nage+Age1-2]',Eretmig1{i}(ist:ist+nage-2),'b--','Linewidth',3.5);
    end
    hold off;

    ylim([0 0.14]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Repeat migration rate: baseline model','Repeat migration rate: less geographic specificity',...
        'Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_experiment_retmig_skills']);
    end

     %%
    figure;    
    plot([Age1:nage+Age1-6]',Eretmig5{1}(ist:ist+nage-6),'r-','Linewidth',3.5);
    hold on; 
    for i= 2:2
        plot([Age1:nage+Age1-6]',Eretmig5{i}(ist:ist+nage-6),'b--','Linewidth',3.5);
    end
    hold off;

    ylim([0 0.5]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Repeat migration rate (5yr): baseline model','Repeat migration rate (5yr): less geographic specificity',...
        'Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_experiment_retmig5_skills']);
    end
%%
    figure;    
    plot([Age1:nage+Age1-1]',Emig{1}(ist:ist+nage-1),'r-','Linewidth',3.5);
    hold on; 
    for i= 3:7
        plot([Age1:nage+Age1-1]',Emig{i}(ist:ist+nage-1),ls{i},'Linewidth',2.5);
    end
    hold off;

    ylim([0 0.16]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Migration rate: baseline model','Migration rate: more information (1 year)',...
           'Migration rate: more information (9 months)',...
           'Migration rate: more information (6 months)',...
           'Migration rate: more information (3 months)',...
           'Migration rate: more information (1 months)',...
           'Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_experiment_migration_info']);
    end
 %%   
    figure;    
    plot([Age1:nage+Age1-1]',Emig{1}(ist:ist+nage-1),'r-','Linewidth',3.5);
    hold on; 
    plot([Age1:nage+Age1-1]',Emig{3}(ist:ist+nage-1),'k-','Linewidth',3.5);
    plot([Age1:nage+Age1-1]',Emig{4}(ist:ist+nage-1),'-.','Linewidth',3.5,'Color',[1 .65 0]);
    plot([Age1:nage+Age1-1]',Emig{5}(ist:ist+nage-1),':','Linewidth',4.5,'Color',[.3 0 .5]);
    plot([Age1:nage+Age1-1]',Emig{6}(ist:ist+nage-1),'b--','Linewidth',3.5);
    plot([Age1:nage+Age1-1]',Emig{7}(ist:ist+nage-1),'y-','Linewidth',3.5);
    hold off;

    ylim([0 0.16]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Migration rate: baseline model','Migration rate: more information (1 year)',...
           'Migration rate: more information (9 months)',...
           'Migration rate: more information (6 months)',...
           'Migration rate: more information (3 months)',...
           'Migration rate: more information (1 months)',...
           'Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_experiment_migration_info_colors']);
    end

%%
    figure;    
    plot([Age1:nage+Age1-5]',Emig5{1}(ist:ist+nage-5),'r-','Linewidth',3.5);
    hold on; 
    plot([Age1:nage+Age1-5]',Emig5{3}(ist:ist+nage-5),'k-','Linewidth',3.5);
    plot([Age1:nage+Age1-5]',Emig5{4}(ist:ist+nage-5),'-.','Linewidth',3.5,'Color',[1 .65 0]);
    plot([Age1:nage+Age1-5]',Emig5{5}(ist:ist+nage-5),':','Linewidth',4.5,'Color',[.3 0 .5]);
    plot([Age1:nage+Age1-5]',Emig5{6}(ist:ist+nage-5),'b--','Linewidth',3.5);
    plot([Age1:nage+Age1-5]',Emig5{7}(ist:ist+nage-5),'y-','Linewidth',3.5);
    hold off;

    ylim([0 0.5]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Migration rate (5yr): baseline model','Migration rate (5yr): more information (1 year)',...
           'Migration rate (5yr): more information (9 months)',...
           'Migration rate (5yr): more information (6 months)',...
           'Migration rate (5yr): more information (3 months)',...
           'Migration rate (5yr): more information (1 months)',...
           'Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_experiment_migration5_info_colors']);
    end
    
    %%
    figure;    
    plot([Age1:nage+Age1-2]',Eretmig1{1}(ist:ist+nage-2),'r-','Linewidth',3.5);
    hold on; 
    for i= 3:7
        plot([Age1:nage+Age1-2]',Eretmig1{i}(ist:ist+nage-2),ls{i},'Linewidth',2.5);
    end
    hold off;

    ylim([0 0.16]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Repeat mig rate: baseline model','Repeat mig rate: more information (1 year)',...
           'Repeat mig rate: more information (9 months)',...
           'Repeat mig rate: more information (6 months)',...
           'Repeat mig rate: more information (3 months)',...
           'Repeat mig rate: more information (1 months)',...
           'Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_experiment_retmig_info']);
    end
    
      %%
    figure;    
    plot([Age1:nage+Age1-6]',Eretmig5{1}(ist:ist+nage-6),'r-','Linewidth',3.5);
    hold on; 
    for i= 3:7
        plot([Age1:nage+Age1-6]',Eretmig5{i}(ist:ist+nage-6),ls{i},'Linewidth',2.5);
    end
    hold off;

    ylim([0 0.5]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Repeat mig rate (5yr): baseline model','Repeat mig rate: more information (1 year)',...
           'Repeat mig rate (5yr): more information (9 months)',...
           'Repeat mig rate (5yr): more information (6 months)',...
           'Repeat mig rate (5yr): more information (3 months)',...
           'Repeat mig rate (5yr): more information (1 months)',...
           'Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_experiment_retmig5_info']);
    end
%%
    figure;    
    plot([Age1:nage+Age1-1]',Emig{1}(ist:ist+nage-1),'r-','Linewidth',3.5);
    hold on; 
    for i= 8:8
        plot([Age1:nage+Age1-1]',Emig{i}(ist:ist+nage-1),'b--','Linewidth',3.5);
    end
    hold off;

    ylim([0 0.16]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Migration rate: baseline model','Migration rate: less geographic specificity \newline + more information (6 months)',...
        'Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_experiment_migration_both']);
    end

    %%
    figure;    
    plot([Age1:nage+Age1-1]',Emig{1}(ist:ist+nage-1),'r-','Linewidth',3.5);
    hold on; 
    plot([Age1:nage+Age1-1]',dataEmig,'r--','Linewidth',1.5);
    for i= 8:8
        plot([Age1:nage+Age1-1]',Emig{i}(ist:ist+nage-1),'b-','Linewidth',3.5);
    end
    plot([Age1:nage+Age1-1]',dataEmigEND,'b--','Linewidth',1.5);
    hold off;

    ylim([0 0.16]);
    xlim([18 55]);
    grid on;
    xlabel('Age','FontSize',16);
    legend('Migration rate: baseline model','Migration rate: data, 1991-97',...
        'Migration rate: less geographic specificity \newline + more information (6 months)',...
        'Migration rate: data, 2005-11',...
        'Location','NorthEast');
    set(gca,'FontSize',16);
    if Save==1 
        print('-depsc',[PlotDir '/' Educ '_experiment_migration_both_withdata']);
    end

%%
    if Transition==1
        figure;
        plot([0:40]',pathEmig(1)*ones(41,1),'k-','Linewidth',3.5);
        hold on;
        plot([0:40]',pathEmig,'r-','Linewidth',3.5);
        plot([0:40]',pathEmig(41)*ones(41,1),'k--','Linewidth',3.5);
        ylim([0 .05]);
        set(gca,'YTick',0:.01:.05,'YTickLabel',num2str([0:.01:.05].','%3.2f\n'));
        xlim([0 40]);
        grid on;
        xlabel('Years after change in parameters','FontSize',16);
        legend('Migration rate in baseline steady state','Transition path','Migration rate in new steady state','Location','SouthEast');
        set(gca,'FontSize',16);
        if Save==1
            print('-depsc',[PlotDir '/' Educ '_transition']);
        end
    end
end    

%% AVERAGE STATS REPORTED IN PAPER
%1: mean mig rate
%2: percent reduction relative to data
%3: percent reduction from baseline
%4: 1 year ret mig
%5: 2 year ret mig
%6: 5 year ret mig
%7: 5 year mig rate
%8: occ switch
%9: percent reduction in 5 year rate from baseline
%10: percent reduction in 1 year ret mig from baseline

for i = 1:nconfig(2)
    avstats(1,i) = i;
    avstats(1+1,i) = mean(Emig{i}(ist:ist+nage-1));
    avstats(2+1,i) = (mean(Emig{1}(ist:ist+nage-1))- mean(Emig{i}(ist:ist+nage-1))) ./ (mean(dataEmig)- mean(dataEmigEND));
    avstats(3+1,i) = 1-mean(Emig{i}(ist:ist+nage-1))./mean(Emig{1}(ist:ist+nage-1));
    avstats(4+1,i) = mean(Eretmig1{i}(ist:ist+nage-2));
    avstats(5+1,i) = mean(Eretmig2{i}(ist:ist+nage-3));
    avstats(6+1,i) = mean(Eretmig5{i}(ist:ist+nage-6));
    avstats(7+1,i) = mean(Emig5{i}(ist:ist+nage-5));
    avstats(8+1,i) = mean(Eswitch{i}(ist:ist+nage-1));
    avstats(9+1,i) = 1-mean(Emig5{i}(ist:ist+nage-5))./mean(Emig5{1}(ist:ist+nage-5));
    avstats(10+1,i) = 1-mean(Eretmig1{i}(ist:ist+nage-2))./mean(Eretmig1{1}(ist:ist+nage-2));
    
end    
    
